#include <linux/types.h>
#include <linux/stat.h>
#include <linux/unistd.h>
#include <linux/time.h>
#include <linux/delay.h>
#include <linux/string.h>

#include "RdsTmcTypes.h"
#include "IRDSListener.h"
#include "I2CForm.h"
#include "TEA5764HN.h"
#include "CTEA5764Driver.h"

//#define SUSRES_DEBUG 1
#define PBYTE char *
//typedef BOOL bool;
/* ʤäƲ۲ */
static II2CForm *pI2CForm;
static IRDSListener *pIRDSListener;
static W_DAT Tea5764WriteData;
static R_DAT Tea5764ReadData;
static bool hlsi;
static bool m_SwPortWriteFlag = false;

/* ؿ */
void *Ctea5764Driver_construct_register(int Mode,int data);
//void *Ctea5764Driver_construct_rds_data(void);
void Ctea5764Driver_MakeInitData(void);
void Ctea5764Driver_MakeInitData2nd(void);
bool Ctea5764Driver_EnableInt(bool);
unsigned long Ctea5764Driver_MakeFreq(unsigned char ,unsigned char );
unsigned long Ctea5764Driver_MakePLL(int );
void Ctea5764Driver_setPower(bool);
void Ctea5764Driver_CheckSeekEndFlag(void);
bool Ctea5764Driver_SeekIntDisable(void);
void Ctea5764Driver_MakeReInitData(void);
bool Ctea5764Driver_CheckDAVFlag(void);
bool Ctea5764CheckSwPort(void);
bool Ctea5764Driver_CompReg(void);
void Ctea5764Driver_PowerdownDebug(void);

/* ѥбΰ٤ */
#define TEA_FREQENCY 0

/* -------------------slave address(First Byte)---------------------- */
/* Read/Write bit */
#define TEA5764_WRITE_MODE 0x00
#define TEA5764_READ_MODE  0x01
#define TEA5764_RW_BIT  0x01

/* SlaveAddress 7bit ȤȤ1bitեȤR/WORƤ */
#define TEA5764_TUNE_RDS_MODE 0x11
#define TEA5764_TUNE_FM_MODE 0x10

#define TEA5764_SLAVE_RDS  0x22
#define TEA5764_SLAVE_FM   0x20

//쥸κ祵
#define TEA5764_READ_MAX 28
#define TEA5764_WRITE_MAX 11

/* ȿߥå */
#define TMCRDS_USEU_FMBAND_LIMIT_MIN 875
#define TMCRDS_USEU_FMBAND_LIMIT_MAX 1080

//RDSǡμ
#define TMC_RDS_READDATASIZE 4
//SWPortޤǽ񤭹Υ
#define RDS_SWPORT_SIZE 5

#ifdef DEB_MSG_ON
#define DEBMSG(a) a
#define DEBMSG_COM(a) a
#define DEBMSG_TIME(a) 
#else
#define DEBMSG(a)
#define DEBMSG_COM(a) 
#define DEBMSG_TIME(a) 
#endif

#define RETAILMSG(...)
#define EXEC_DEBMSG(a)
//#define TEXT(a) a
//#define RETAILMSG(b,...) printk(...)

/*---------------------------------------------------------------------------------------
			ǥХʽѡ
----------------------------------------------------------------------------------------*/
BOOL Ctea5764Driver_init(IRDSListener *ListenerPtr,II2CForm *II2CFormPtr)
{
//	unsigned char bFirstByte;
	unsigned long dwSendSize;
	long dwExecSendSize;
	int initLoop = 0;
//	int loop = 0;
	pIRDSListener = NULL;
	pI2CForm = NULL;
	pIRDSListener = ListenerPtr;
	pI2CForm = II2CFormPtr;
//	if ((pIRDSListener == NULL) || (pI2CForm == NULL)) {
//		return FALSE;
//	}
	if (pI2CForm->i2c_recv == NULL) {
		return FALSE;
	}
	if (pI2CForm->i2c_send == NULL) {
		return FALSE;
	}
	(pI2CForm->i2c_init)();
	hlsi = TRUE;
	m_SwPortWriteFlag = false;
	//֤Υǡ
//	bFirstByte = (unsigned char)((TEA5764_TUNE_FM_MODE << 1) | TEA5764_RW_BIT);
	dwSendSize = TEA5764_READ_MAX;
	if(!(pI2CForm->i2c_recv)((unsigned char)((TEA5764_TUNE_FM_MODE << 1) | TEA5764_RW_BIT),(char *)Tea5764ReadData.buff,dwSendSize,&dwExecSendSize)) {
			printk(KERN_ERR "init 4.5\r\n");
		return FALSE;
	}
	if (dwExecSendSize != TEA5764_READ_MAX) {
		printk(KERN_ERR "Ctea5764Driver_init init read error %d\n",(int)dwExecSendSize);
		return FALSE;
	}
#if 0
	for(loop = 0;loop < dwExecSendSize;loop++){
		EXEC_DEBMSG(printk("Ctea5764Driver_get_allreg reg%d 0x%X\n",loop,Tea5764ReadData.buff[loop]);)
	}
#endif
	initLoop = 0;
	while(initLoop < 3) {
		initLoop++;
		//TEA5764˽ͤꤹ
		Ctea5764Driver_MakeInitData();
//		bFirstByte = (unsigned char)(TEA5764_TUNE_FM_MODE << 1);
		dwSendSize = TEA5764_WRITE_MAX;
		dwExecSendSize = 0;
		if(!(pI2CForm->i2c_send)((unsigned char)((TEA5764_TUNE_FM_MODE << 1) & ~TEA5764_RW_BIT),(char *)Tea5764WriteData.buff,dwSendSize,&dwExecSendSize)) {
			return false;
		}
		if (dwExecSendSize != TEA5764_WRITE_MAX) {
			RETAILMSG(1, (TEXT("Ctea5764Driver_init init send error\r\n")));
			continue;
		}

//RETAILMSG(1, (TEXT("init 3\r\n")));
		//Ÿ
//		Ctea5764Driver_setPower(TRUE);

		//ɤ߽Фɤ߽Ф
//		bFirstByte = (unsigned char)((TEA5764_TUNE_FM_MODE << 1) | TEA5764_RW_BIT);
		dwSendSize = TEA5764_READ_MAX;
		if(!(pI2CForm->i2c_recv)((unsigned char)((TEA5764_TUNE_FM_MODE << 1) | TEA5764_RW_BIT),(char *)Tea5764ReadData.buff,dwSendSize,&dwExecSendSize)) {
			RETAILMSG(1, (TEXT("Ctea5764Driver_init read error\r\n")));
			return FALSE;
		}
		if (dwExecSendSize != TEA5764_READ_MAX) {
			RETAILMSG(1, (TEXT("Ctea5764Driver_init read error2\r\n")));
			continue;
		}
//		for(loop = 0;loop < dwExecSendSize;loop++){
//			EXEC_DEBMSG(printk("Ctea5764Driver_get_allreg reg%d 0x%X\n",loop,Tea5764ReadData.buff[loop]);)
//		}
		if(Ctea5764Driver_CompReg()) {
//			RETAILMSG(1, (TEXT("init OK\r\n")));
			printk(KERN_INFO "TE5764 init OK\r\n");
			return TRUE;
		} else {
			//ޤ񤭹߽Ƥʤ褦ʤȥ饤Ƥߤ
			continue;
		}
	}
	return FALSE;
}
/*---------------------------------------------------------------------------------------
			쥸
----------------------------------------------------------------------------------------*/
bool Ctea5764Driver_CompReg()
{
	int regloop = 0;
	for(regloop = 0;regloop < 5;regloop++) {
		if(Tea5764WriteData.buff[regloop] != Tea5764ReadData.buff[regloop+1] ) {
			RETAILMSG(1, (TEXT("Comp False 1\r\n")));
			return false;
		}
//	RETAILMSG(1, (TEXT("Tea5764WriteData%d 0x%X\r\n"),regloop,Tea5764WriteData.buff[regloop]));

	}
	if(Tea5764WriteData.buff[5] != Tea5764ReadData.buff[10] ) {
			RETAILMSG(1, (TEXT("Comp False 2\r\n")));
			return false;
	}
//	RETAILMSG(1, (TEXT("Tea5764WriteData5 0x%X\r\n"),Tea5764WriteData.buff[5]));
	if(Tea5764WriteData.buff[6] != Tea5764ReadData.buff[11] ) {
			RETAILMSG(1, (TEXT("Comp False 3\r\n")));
			return false;
	}
//	RETAILMSG(1, (TEXT("Tea5764WriteData6 0x%X\r\n"),Tea5764WriteData.buff[6]));
	for(regloop = 7;regloop < 11;regloop++) {
		if(Tea5764WriteData.buff[regloop] != Tea5764ReadData.buff[regloop + 13] ) {
			RETAILMSG(1, (TEXT("Comp False 4\r\n")));
			return false;
		}
//	RETAILMSG(1, (TEXT("Tea5764WriteData%d 0x%X\r\n"),regloop,Tea5764WriteData.buff[regloop]));
	}
//	for(regloop = 0;regloop < 28;regloop++) {
//		RETAILMSG(1, (TEXT("Tea5764ReadData%d 0x%X\r\n"),regloop,(char *)Tea5764ReadData.buff[regloop]));
//	}
//	RETAILMSG(1, (TEXT("Comp OK\r\n")));
	return true;

}
/*---------------------------------------------------------------------------------------
			ǥХ2ܰʹߡ
----------------------------------------------------------------------------------------*/
BOOL Ctea5764Driver_init2nd(IRDSListener *ListenerPtr,II2CForm *II2CFormPtr)
{
//	unsigned char bFirstByte;
	unsigned long dwSendSize;
	long dwExecSendSize;
	int initLoop = 0;

	pIRDSListener = NULL;
	pI2CForm = NULL;
	pIRDSListener = ListenerPtr;
	pI2CForm = II2CFormPtr;
	hlsi = TRUE;
	m_SwPortWriteFlag = false;
	if ((pIRDSListener == NULL) || (pI2CForm == NULL)) {
		return FALSE;
	}
	if ((pI2CForm->i2c_recv == NULL) || (pI2CForm->i2c_send == NULL)) {
	}
	//֤Υǡ
//	bFirstByte = (unsigned char)((TEA5764_TUNE_FM_MODE << 1) | TEA5764_RW_BIT);
	dwSendSize = TEA5764_READ_MAX;
	if(!(pI2CForm->i2c_recv)((unsigned char)((TEA5764_TUNE_FM_MODE << 1) | TEA5764_RW_BIT),(char *)Tea5764ReadData.buff,dwSendSize,&dwExecSendSize)) {
		return FALSE;
	}
	if (dwExecSendSize != TEA5764_READ_MAX) {
//		RETAILMSG(1, (TEXT("init 1\r\n")));
		return FALSE;
	}

	initLoop = 0;
	while(initLoop < 3) {
		initLoop++;
		//TEA5764˽ͤꤹ
		Ctea5764Driver_MakeInitData2nd();
//		bFirstByte = (unsigned char)(TEA5764_TUNE_FM_MODE << 1);
		dwSendSize = TEA5764_WRITE_MAX;
		dwExecSendSize = 0;
		if(!(pI2CForm->i2c_send)((unsigned char)((TEA5764_TUNE_FM_MODE << 1) & ~TEA5764_RW_BIT),(char *)Tea5764WriteData.buff,dwSendSize,&dwExecSendSize)) {
			return false;
		}
		if (dwExecSendSize != TEA5764_WRITE_MAX) {
//			RETAILMSG(1, (TEXT("init 2\r\n")));
			continue;
		}

	//RETAILMSG(1, (TEXT("init 3\r\n")));
		//Ÿ
		Ctea5764Driver_setPower(TRUE);

		//ɤ߽Фɤ߽Ф
//		bFirstByte = (unsigned char)((TEA5764_TUNE_FM_MODE << 1) | TEA5764_RW_BIT);
		dwSendSize = TEA5764_READ_MAX;
		if(!(pI2CForm->i2c_recv)((unsigned char)((TEA5764_TUNE_FM_MODE << 1) | TEA5764_RW_BIT),(char *)Tea5764ReadData.buff,dwSendSize,&dwExecSendSize)) {
			return FALSE;
		}
		if (dwExecSendSize != TEA5764_READ_MAX) {
//			RETAILMSG(1, (TEXT("init 4\r\n")));
			continue;
		}
		if(Ctea5764Driver_CompReg()) {
//			RETAILMSG(1, (TEXT("init OK\r\n")));
			return TRUE;
		} else {
			//ޤ񤭹߽Ƥʤ褦ʤȥ饤Ƥߤ
			continue;
		}
	}
//RETAILMSG(1, (TEXT("init 5\r\n")));
	return FALSE;
}

/*---------------------------------------------------------------------------------------
			ǥХ
----------------------------------------------------------------------------------------*/
BOOL Ctea5764Driver_ReInit(IRDSListener *ListenerPtr,II2CForm *II2CFormPtr)
{
//	unsigned char bFirstByte;
	unsigned long dwSendSize;
	long dwExecSendSize;
	int initLoop = 0;

	pIRDSListener = NULL;
	pI2CForm = NULL;
	pIRDSListener = ListenerPtr;
	pI2CForm = II2CFormPtr;
	hlsi = TRUE;
	m_SwPortWriteFlag = false;
	if ((pIRDSListener == NULL) || (pI2CForm == NULL)) {
		return FALSE;
	}
	//	bFirstByte = (unsigned char)((TEA5764_TUNE_FM_MODE << 1) | TEA5764_RW_BIT);
	dwSendSize = TEA5764_READ_MAX;
	if(!(pI2CForm->i2c_recv)((unsigned char)((TEA5764_TUNE_FM_MODE << 1) | TEA5764_RW_BIT),(char *)Tea5764ReadData.buff,dwSendSize,&dwExecSendSize)) {
		return FALSE;
	}
	if (dwExecSendSize != TEA5764_READ_MAX) {
		return FALSE;
	}
	initLoop = 0;
	while(initLoop < 3) {
		initLoop++;
		Ctea5764Driver_MakeReInitData();
//		bFirstByte = (unsigned char)(TEA5764_TUNE_FM_MODE << 1);
		dwSendSize = TEA5764_WRITE_MAX;
		dwExecSendSize = 0;
		if(!(pI2CForm->i2c_send)((unsigned char)((TEA5764_TUNE_FM_MODE << 1) & ~TEA5764_RW_BIT),(char *)Tea5764WriteData.buff,dwSendSize,&dwExecSendSize)) {
			return FALSE;
		}
		if (dwExecSendSize != TEA5764_WRITE_MAX) {
			continue;
		}

		//Ÿ
		Ctea5764Driver_setPower(TRUE);

		//ɤ߽Фɤ߽Ф
//		bFirstByte = (unsigned char)((TEA5764_TUNE_FM_MODE << 1) | TEA5764_RW_BIT);
		dwSendSize = TEA5764_READ_MAX;
		if(!(pI2CForm->i2c_recv)((unsigned char)((TEA5764_TUNE_FM_MODE << 1) | TEA5764_RW_BIT),(char *)Tea5764ReadData.buff,dwSendSize,&dwExecSendSize)) {
			return FALSE;
		}
		if (dwExecSendSize != TEA5764_READ_MAX) {
			continue;
		}
		if(Ctea5764Driver_CompReg()) {
//			RETAILMSG(1, (TEXT("init OK\r\n")));
			return TRUE;
		} else {
			//ޤ񤭹߽Ƥʤ褦ʤȥ饤Ƥߤ
			continue;
		}
	}
	return TRUE;
}

BOOL Ctea5764Driver_LocalReInit(void)
{
//	unsigned char bFirstByte;
	unsigned long dwSendSize;
	long dwExecSendSize;
	int initLoop = 0;

	hlsi = TRUE;
	m_SwPortWriteFlag = false;
	if ((pIRDSListener == NULL) || (pI2CForm == NULL)) {
		return FALSE;
	}
//	bFirstByte = (unsigned char)((TEA5764_TUNE_FM_MODE << 1) | TEA5764_RW_BIT);
	dwSendSize = TEA5764_READ_MAX;
	if(!(pI2CForm->i2c_recv)((unsigned char)((TEA5764_TUNE_FM_MODE << 1) | TEA5764_RW_BIT),(char *)Tea5764ReadData.buff,dwSendSize,&dwExecSendSize)) {
		return FALSE;
	}
	if (dwExecSendSize != TEA5764_READ_MAX) {
		return FALSE;
	}
	initLoop = 0;
	while(initLoop < 3) {
		initLoop++;
//		Ctea5764Driver_MakeReInitData();
		Ctea5764Driver_MakeInitData2nd();
		//Search Mode =PresetMode
		Tea5764WriteData.buff[1] &= ~TEA5764_FRQSETM_SM;
		//IF Count time 15msꤹ
		Tea5764WriteData.buff[3]  |= TEA5764_TNCTRL1_IFCTC;			/* 1: 15ms*/
		if (hlsi) {
			Tea5764WriteData.buff[4] |= TEA5764_TNCTRL2_HLSI;
		} else {
			Tea5764WriteData.buff[4] &= ~TEA5764_TNCTRL2_HLSI;
		}

//		bFirstByte = (unsigned char)(TEA5764_TUNE_FM_MODE << 1);
		dwSendSize = TEA5764_WRITE_MAX;
		dwExecSendSize = 0;
		if(!(pI2CForm->i2c_send)((unsigned char)((TEA5764_TUNE_FM_MODE << 1) & ~TEA5764_RW_BIT),(char *)Tea5764WriteData.buff,dwSendSize,&dwExecSendSize)) {
			return FALSE;
		}
		if (dwExecSendSize != TEA5764_WRITE_MAX) {
			continue;
		}

		//Ÿ
		Ctea5764Driver_setPower(TRUE);

		//ɤ߽Фɤ߽Ф
//		bFirstByte = (unsigned char)((TEA5764_TUNE_FM_MODE << 1) | TEA5764_RW_BIT);
		dwSendSize = TEA5764_READ_MAX;
		if(!(pI2CForm->i2c_recv)((unsigned char)((TEA5764_TUNE_FM_MODE << 1) | TEA5764_RW_BIT),(char *)Tea5764ReadData.buff,dwSendSize,&dwExecSendSize)) {
			return FALSE;
		}
		if (dwExecSendSize != TEA5764_READ_MAX) {
			continue;
		}
		if(Ctea5764Driver_CompReg()) {
//			RETAILMSG(1, (TEXT("init OK\r\n")));
			return TRUE;
		} else {
			//ޤ񤭹߽Ƥʤ褦ʤȥ饤Ƥߤ
			continue;
		}
	}
	return TRUE;
}

BOOL Ctea5764Driver_PowerUpInit(void)
{
	long dwExecSendSize;
	unsigned long dwSendSize;
	Ctea5764Driver_MakeReInitData();
	dwSendSize = TEA5764_WRITE_MAX;
	dwExecSendSize = 0;
#ifdef SUSRES_DEBUG
//	Ctea5764Driver_PowerdownDebug();
#endif
//	RETAILMSG(1, (TEXT("TMC PW init\r\n")));
	if (pI2CForm == NULL) {
		return TRUE;
	}
	(pI2CForm->i2c_PwSend)((unsigned char)(TEA5764_TUNE_FM_MODE << 1),
						(char *)Tea5764WriteData.buff,dwSendSize,&dwExecSendSize);
//			RETAILMSG(1, (TEXT("TMC PW init2\r\n")));
	if (dwExecSendSize != (long)dwSendSize) {
//			RETAILMSG(1, (TEXT("TMC PW init error\r\n")));
		return FALSE;
	}
//			RETAILMSG(1, (TEXT("TMC PW init4\r\n")));
	return TRUE;
}
void Ctea5764Driver_PowerdownDebug(void)
{
#ifdef SUSRES_DEBUG
	int i = 0;
	for (i = 0;i < 11;i++) {
		RETAILMSG(1, (TEXT("TMC down 0x%X\r\n"),(unsigned char)Tea5764WriteData.buff[i]));
	}
#endif
}

/*---------------------------------------------------------------------------------------
			ǥХλ
----------------------------------------------------------------------------------------*/
void Ctea5764Driver_exit(void)
{
	//Power-OffˤƤ
	long dwExecSendSize = 0;
	Tea5764WriteData.PUPD   = 0;	/* 0: all off */
	//Ȥ
	Tea5764WriteData.buff[0] = 0;
	if (pI2CForm == NULL) {
		return;
	}
	if (!(pI2CForm->i2c_send)((unsigned char)((TEA5764_TUNE_FM_MODE << 1) & ~TEA5764_RW_BIT),
								(char *)Tea5764WriteData.buff,TEA5764_WRITE_MAX,&dwExecSendSize)) {
	}
//	IRDSListener = NULL;
//	I2CForm = NULL;
//	memset(&Tea5764WriteData,0,sizeof(W_DAT));
//	memset(&Tea5764ReadData,0,sizeof(R_DAT));
}

/*---------------------------------------------------------------------------------------
			LinuxCE̳ߥϥɥ
----------------------------------------------------------------------------------------*/
#define TMC_ALL_RDS_SIZE 12
#define TMC_LAST_RDS_SIZE 8
#define TMC_RDS_OFFSET_SIZE 12

//#define DEB_INTMSG(a) a
#define DEB_INTMSG(a)

BOOL Ctea5764Driver_int_handler(void)
{
	//ǥХǡɤ߽Ф
//	char *Buffer = NULL;
	unsigned long dwReadSzie;
	long dwExecReadSzie;
//	bool Error = false;
	dwReadSzie = 8;
	dwExecReadSzie = 0;
//	Buffer = (char *)malloc(dwReadSzie);
	DEB_INTMSG(printk(KERN_EMERG "int in start\n");)
	//װFLAGDAVFLAGʳ1RINTMASKˤɤޤʤȥꥢʤ
	//DAVFLAG15R or 17Rǥꥢ롣
	//ʤΤ1R2Rɤߤޤ
	/* RDS Mode Read */
	if (pI2CForm == NULL) {
		return FALSE;
	}
	/* װμ */
	if (!(pI2CForm->i2c_recv)((unsigned char)((TEA5764_TUNE_FM_MODE << 1) | TEA5764_RW_BIT),
		(char *)Tea5764ReadData.buff, 2,&dwExecReadSzie)) {
		return false;
	}
	DEB_INTMSG(printk(KERN_EMERG "int in 0x%X 0x%X 0x%X\n",Tea5764ReadData.buff[0],Tea5764ReadData.buff[1],Tea5764WriteData.buff[0]);)
	/* DAVΩäƤ̵˥ǡäȤޤ */
	if (
		(Tea5764WriteData.buff[0] & TEA5764_INTMASK_DAVMSK) == TEA5764_INTMASK_DAVMSK
		) {
		if (
			(Tea5764ReadData.buff[0] & TEA_INTFLAG_DAVFLG) == TEA_INTFLAG_DAVFLG
			) {
			//٥Ȥɤ߽ФƬɤ߽Ф
#ifdef TMC_ALL_DATA
			if(!(pI2CForm->i2c_recv)((unsigned char)((TEA5764_TUNE_FM_MODE << 1) | TEA5764_RW_BIT),
				(char *)&(Tea5764ReadData.buff[0]),24,&dwExecReadSzie)) {
				return false;
			}
#else
			if(!(pI2CForm->i2c_recv)((unsigned char)((TEA5764_TUNE_RDS_MODE << 1) | TEA5764_RW_BIT),
				(char *)&(Tea5764ReadData.buff[12]),8,&dwExecReadSzie)) {
				return false;
			}
#endif
			if ((Tea5764ReadData.buff[0] & TEA_INTFLAG_DAVFLG) == TEA_INTFLAG_DAVFLG) {
				(pIRDSListener->update_rds_data)(2,&(Tea5764ReadData.buff[0]),12);
			}
		}
		//ꤹߤκ
		if(
			(Tea5764WriteData.buff[0] & TEA5764_INTMASK_DAVMSK) == TEA5764_INTMASK_DAVMSK
		) {
			Tea5764WriteData.buff[0] |= TEA5764_INTMASK_DAVMSK;
		}
	}	
	//Data Available Flagå
	//ͥ븫Ĥäorץꥻå
	if (
		((Tea5764ReadData.buff[0] & TEA_INTFLAG_IFFLAG) != TEA_INTFLAG_IFFLAG) &&
		((Tea5764ReadData.buff[0] & TEA_INTFLAG_BLFLAG) != TEA_INTFLAG_BLFLAG) &&
		((Tea5764ReadData.buff[0] & TEA_INTFLAG_FRRFLAG) == TEA_INTFLAG_FRRFLAG)
	){
			//ͥ븫ĤäorץꥻåḫĤä
			if ((Tea5764WriteData.buff[1] & TEA5764_FRQSETM_SM) == TEA5764_FRQSETM_SM) {
#ifdef SLEEP_ON
#ifdef WINCE
				Sleep(15);
#else
//			mdelay(15);
#endif
#endif
				//IF Counttime2msRDSΰ١ѻWriteϤȤ礹
				if(!(pI2CForm->i2c_recv)((unsigned char)((TEA5764_TUNE_FM_MODE << 1) | TEA5764_RW_BIT),
					(char *)Tea5764ReadData.buff, 8,&dwExecReadSzie)) {
					return false;
				}
				//ꤹߤκ
				Tea5764WriteData.buff[0] &= ~(TEA5764_INTMASK_FRMSK | TEA5764_INTMASK_BLMSK | TEA5764_INTMASK_IFMSK);
				Tea5764WriteData.buff[1] = (unsigned char)(Tea5764ReadData.buff[6] & 0x3f);		//PLL hight byte
				Tea5764WriteData.buff[2] = (unsigned char)(Tea5764ReadData.buff[7] & 0xff);			//PLL Low byte
				Tea5764WriteData.buff[1] &= ~TEA5764_FRQSETM_SM;
				(pIRDSListener->update_rds_data)(0,NULL,0);

				DEB_INTMSG(printk(KERN_EMERG "------- SEEK End1------- \n");)
			} else {
				Tea5764WriteData.buff[0] &= ~TEA5764_INTMASK_FRMSK;
				(pIRDSListener->update_rds_data)(3,NULL,0);
				DEB_INTMSG(printk(KERN_EMERG "------- Preset End1------- \n");)
			}


	//ͥ븫ĤäƥХɥߥåȤˤʤäå
	} else if(
		((Tea5764ReadData.buff[0] & TEA_INTFLAG_IFFLAG) != TEA_INTFLAG_IFFLAG) &&
		((Tea5764ReadData.buff[0] & TEA_INTFLAG_BLFLAG) == TEA_INTFLAG_BLFLAG) &&
		((Tea5764ReadData.buff[0] & TEA_INTFLAG_FRRFLAG) == TEA_INTFLAG_FRRFLAG)
	){
		//SM=1 Search Modeʤ
		if ((Tea5764WriteData.buff[1] & TEA5764_FRQSETM_SM) == TEA5764_FRQSETM_SM) {
			DEB_INTMSG(printk(KERN_EMERG "------- SEEK End2------- \n");)
			//ͥ븫ĤäƥХɥߥåȤˤʤäḫĤä
			(pIRDSListener->update_rds_data)(0,NULL,0);

			//IF Counttime2msRDSΰ١ѻWriteϤȤ礹
			if(!(pI2CForm->i2c_recv)((unsigned char)((TEA5764_TUNE_FM_MODE << 1) | TEA5764_RW_BIT),
				(char *)Tea5764ReadData.buff, 8,&dwExecReadSzie)) {
				return false;
			}
			//ꤹߤκ
			Tea5764WriteData.buff[0] &= ~(TEA5764_INTMASK_FRMSK | TEA5764_INTMASK_BLMSK | TEA5764_INTMASK_IFMSK);
			Tea5764WriteData.buff[1] = (unsigned char)(Tea5764ReadData.buff[6] & 0x3f);		//PLL hight byte
			Tea5764WriteData.buff[2] = (unsigned char)(Tea5764ReadData.buff[7] & 0xff);			//PLL Low byte
			Tea5764WriteData.buff[1] &= ~TEA5764_FRQSETM_SM;
		}
		//ꤹߤκ
		Tea5764WriteData.buff[0] &= ~(TEA5764_INTMASK_FRMSK | TEA5764_INTMASK_BLMSK | TEA5764_INTMASK_IFMSK);

	//ͥ븫ĤäͭRSSI٥뤢뤱ɡ
	} else if(
		((Tea5764ReadData.buff[0] & TEA_INTFLAG_IFFLAG) == TEA_INTFLAG_IFFLAG) &&
		((Tea5764ReadData.buff[0] & TEA_INTFLAG_BLFLAG) != TEA_INTFLAG_BLFLAG) &&
		((Tea5764ReadData.buff[0] & TEA_INTFLAG_FRRFLAG) == TEA_INTFLAG_FRRFLAG)
	){
		//Preset orSearch ModeɤǤOK
		if ((Tea5764WriteData.buff[1] & TEA5764_FRQSETM_SM) == TEA5764_FRQSETM_SM) {
			//ͥ븫ĤäͭRSSI٥뤢뤱ɡԡḫĤä
			DEB_INTMSG(printk(KERN_EMERG "------- SEEK End3------- \n");)
			(pIRDSListener->update_rds_data)(0,NULL,0);
			//IF Counttime2msRDSΰ١ѻWriteϤȤ礹
			if(!(pI2CForm->i2c_recv)((unsigned char)((TEA5764_TUNE_FM_MODE << 1) | TEA5764_RW_BIT),
				(char *)Tea5764ReadData.buff, 8,&dwExecReadSzie)) {
				return false;
			}
			//ꤹߤκ
			Tea5764WriteData.buff[0] &= ~(TEA5764_INTMASK_FRMSK | TEA5764_INTMASK_BLMSK | TEA5764_INTMASK_IFMSK);
			Tea5764WriteData.buff[1] = (unsigned char)(Tea5764ReadData.buff[6] & 0x3f);		//PLL hight byte
			Tea5764WriteData.buff[2] = (unsigned char)(Tea5764ReadData.buff[7] & 0xff);			//PLL Low byte
			Tea5764WriteData.buff[1] &= ~TEA5764_FRQSETM_SM;

		} else if ((Tea5764WriteData.buff[1] & TEA5764_FRQSETM_SM) != TEA5764_FRQSETM_SM) {
			Tea5764WriteData.buff[0] &= ~TEA5764_INTMASK_FRMSK;
			(pIRDSListener->update_rds_data)(3,NULL,0);
			DEB_INTMSG(printk(KERN_EMERG "------- Preset End2------- \n");)
		}
		//ꤹߤκ
		Tea5764WriteData.buff[0] &= ~(TEA5764_INTMASK_FRMSK | TEA5764_INTMASK_BLMSK | TEA5764_INTMASK_IFMSK);

	//ĤʤޤޥߥåȤˤʤä
	} else if(
		((Tea5764ReadData.buff[0] & TEA_INTFLAG_IFFLAG) == TEA_INTFLAG_IFFLAG) &&
		((Tea5764ReadData.buff[0] & TEA_INTFLAG_BLFLAG) == TEA_INTFLAG_BLFLAG) &&
		((Tea5764ReadData.buff[0] & TEA_INTFLAG_FRRFLAG) == TEA_INTFLAG_FRRFLAG)
	){
		//ꤹߤκ
		Tea5764WriteData.buff[0] &= ~(TEA5764_INTMASK_FRMSK | TEA5764_INTMASK_BLMSK | TEA5764_INTMASK_IFMSK);
		//SM=1 Search Modeʤ
		if ((Tea5764WriteData.buff[1] & TEA5764_FRQSETM_SM) == TEA5764_FRQSETM_SM) {
			//ĤʤޤޥߥåȤˤʤä
			DEB_INTMSG(printk(KERN_EMERG "------- SEEK End4------- \n");)
			//IF Counttime2msRDSΰ١ѻWriteϤȤ礹
			if(!(pI2CForm->i2c_recv)((unsigned char)((TEA5764_TUNE_FM_MODE << 1) | TEA5764_RW_BIT),
				(char *)Tea5764ReadData.buff, 8,&dwExecReadSzie)) {
				return false;
			}
			//ꤹߤκ
			Tea5764WriteData.buff[0] &= ~(TEA5764_INTMASK_FRMSK | TEA5764_INTMASK_BLMSK | TEA5764_INTMASK_IFMSK);
			Tea5764WriteData.buff[1] = (unsigned char)(Tea5764ReadData.buff[6] & 0x3f);		//PLL hight byte
			Tea5764WriteData.buff[2] = (unsigned char)(Tea5764ReadData.buff[7] & 0xff);			//PLL Low byte
			Tea5764WriteData.buff[1] &= ~TEA5764_FRQSETM_SM;

			(pIRDSListener->update_rds_data)(1,NULL,0);
		}
	}
	//ߺ
	Ctea5764Driver_EnableInt(TRUE);
//	DEBMSG_TIME(RETAILMSG(1, (TEXT("int out %d\r\n"),GetTickCount()));)
	DEB_INTMSG(printk(KERN_EMERG "int out\n");)
	return TRUE;
}

/*---------------------------------------------------------------------------------------
			ų
----------------------------------------------------------------------------------------*/
short Ctea5764Driver_getLevel(void)
{
	long dwExecSendSize;

	static short level = 0;
	if (pI2CForm == NULL) {
		return -1;
	}
	if(!(pI2CForm->i2c_recv)((unsigned char)((TEA5764_TUNE_FM_MODE << 1) | TEA5764_RW_BIT),
		(char *)Tea5764ReadData.buff, 10,&dwExecSendSize)) {
		return -1;
	}
	if (dwExecSendSize != 0) {
		level = (short)((Tea5764ReadData.buff[9] >> 4)&0x0f);
	} else {
		level = -1;
	}

	//ǡå
	Ctea5764Driver_CheckDAVFlag();

//	Ctea5764Driver_CheckSeekEndFlag();

	Ctea5764Driver_EnableInt(TRUE);
	return level;
}

/*---------------------------------------------------------------------------------------
			ȿ
----------------------------------------------------------------------------------------*/
#define RDS_GETFREQ_SIZE 8
int  Ctea5764Driver_getFreq(void) {
	long dwExecSendSize;
	int Freq = 0;
#ifdef FLAOT_ENABLE
	float f;
#else
	long f;
#endif
	int retrycnt = 0;
	if (pI2CForm == NULL) {
		return -1;
	}
TMC_FREQ_RETRY:
//	if ((Tea5764WriteData.buff[0] & TEA5764_INTMASK_DAVMSK) != TEA5764_INTMASK_DAVMSK)  {
		if(!(pI2CForm->i2c_recv)((unsigned char)((TEA5764_TUNE_FM_MODE << 1) | TEA5764_RW_BIT),
			(char *)Tea5764ReadData.buff, RDS_GETFREQ_SIZE,&dwExecSendSize)) {
			return -1;
		}
		if (dwExecSendSize != RDS_GETFREQ_SIZE) {
			return -1;
		}
		//ǡå
		Ctea5764Driver_CheckDAVFlag();

//		Ctea5764Driver_CheckSeekEndFlag();
		//ߺ
		Ctea5764Driver_EnableInt(TRUE);
//	}
	EXEC_DEBMSG(printk("reg 2 0x%X\n",Tea5764ReadData.buff[2]);)
	EXEC_DEBMSG(printk("reg 3 0x%X\n",Tea5764ReadData.buff[3]);)
	EXEC_DEBMSG(printk("reg 6 0x%X\n",Tea5764ReadData.buff[6]);)
	EXEC_DEBMSG(printk("reg 7 0x%X\n",Tea5764ReadData.buff[7]);)
//	Ctea5764Driver_MakeFreq(Tea5764ReadData.PLL_H,Tea5764ReadData.PLL_L);
#ifdef FLAOT_ENABLE
	f = (float)((Tea5764ReadData.PLL_H << 8) + Tea5764ReadData.PLL_L);
#else
	f = (long)((Tea5764ReadData.PLL_H << 8) + Tea5764ReadData.PLL_L);
	EXEC_DEBMSG(printk("Tea5764ReadData.PLL_H 0x%X\n",Tea5764ReadData.PLL_H);)
	EXEC_DEBMSG(printk("Tea5764ReadData.PLL_L 0x%X\n",Tea5764ReadData.PLL_L);)
#endif
	EXEC_DEBMSG(printk("PLL 0x%X\n",(int)f);)
	f *= (long)(32768 / 4);
	EXEC_DEBMSG(printk("PLL 2 %d\n",(int)f);)
	f -= hlsi ? 225000 : -225000;
	EXEC_DEBMSG(printk("PLL 3 %d\n",(int)f);)
	f /= 100000;
	EXEC_DEBMSG(printk("PLL 4 %d\n",(int)f);)
	Freq = (int)(f+(long)hlsi);
	EXEC_DEBMSG(printk("FREQ %d\n",Freq);)
	if((Freq < TMCRDS_USEU_FMBAND_LIMIT_MIN) || (Freq > TMCRDS_USEU_FMBAND_LIMIT_MAX)) {
		//󥸳ʤΤΤʤ˼곰Ƥ뤫⤷ʤΤƤߤ
		Ctea5764Driver_LocalReInit();
#ifdef SLEEP_ON
#ifdef WINCE
		Sleep(15);
#else
//		mdelay(15);
#endif
#endif
#if 0
		RETAILMSG(1, (TEXT("Freq OutRange %d %d %X %X\r\n"),Freq,retrycnt,Tea5764ReadData.PLL_H,Tea5764ReadData.PLL_L));
		if(!(pI2CForm->i2c_recv)((unsigned char)((TEA5764_TUNE_FM_MODE << 1) | TEA5764_RW_BIT),
			(char *)Tea5764ReadData.buff, 28,&dwExecSendSize)) {
			RETAILMSG(1, (TEXT("All Read error\r\n")));
		} else {
			if(dwExecSendSize != 28) {
				RETAILMSG(1, (TEXT("All Read size error %d\r\n"),dwExecSendSize));
			}
			for (regloop = 0; regloop < 28;regloop++) {
				RETAILMSG(1, (TEXT("Tea5764ReadData%d 0x%X\r\n"),regloop,Tea5764ReadData.buff[regloop]));
			}

		}
#endif
		if (retrycnt == 0) {
			retrycnt++;
			goto TMC_FREQ_RETRY;
		}
	}
	return Freq;
}

/*---------------------------------------------------------------------------------------
			ץꥻåȼ
----------------------------------------------------------------------------------------*/
#define RDS_FREQCTRL_SIZE 5
#define TEAMSG_TUNE(a)
bool Ctea5764Driver_tune(int freq) {
	long dwExecSendSize;
	unsigned long n = Ctea5764Driver_MakePLL(freq);
	
	TEAMSG_TUNE(printk("Ctea5764Driver_tune Freq %d\n",freq);)
	if (pI2CForm == NULL) {
		return false;
	}
	Tea5764WriteData.buff[1] = (unsigned char)((n >> 8) & 0xff);	//PLL hight byte
	Tea5764WriteData.buff[2] = (unsigned char)(n & 0xff);			//PLL Low byte
	TEAMSG_TUNE(printk("Tea5764WriteData.buff[1] 0x%X\n",Tea5764WriteData.buff[1]);)
	TEAMSG_TUNE(printk("Tea5764WriteData.buff[2] 0x%X\n",Tea5764WriteData.buff[2]);)
	//high-side injection?
	if (hlsi) {
		Tea5764WriteData.buff[4] |= TEA5764_TNCTRL2_HLSI;
	} else {
		Tea5764WriteData.buff[4] &= ~TEA5764_TNCTRL2_HLSI;
	}
	//Search Mode =PresetMode
	Tea5764WriteData.buff[1] &= ~TEA5764_FRQSETM_SM;
	//PresetΤFRRFLAG
	Tea5764WriteData.buff[0] |= TEA5764_INTMASK_FRMSK;
	//IF Count time 15msꤹ
	Tea5764WriteData.buff[3]  |= TEA5764_TNCTRL1_IFCTC;			/* 1: 15ms*/
	TEAMSG_TUNE(printk(KERN_EMERG "Ctea5764Driver_tune Tea5764WriteData.buff[0] %X\n",Tea5764WriteData.buff[0]);)

	if(!(pI2CForm->i2c_send)((unsigned char)((TEA5764_TUNE_FM_MODE << 1) & ~TEA5764_RW_BIT),
		(char *)Tea5764WriteData.buff, RDS_FREQCTRL_SIZE,&dwExecSendSize)){
		return false;
	}
	if (dwExecSendSize != RDS_FREQCTRL_SIZE) {
		return false;
	}
#ifdef SLEEP_ON
#ifdef WINCE
		Sleep(20);
#else
//		mdelay(20);
#endif
#endif
	TEAMSG_TUNE(printk("Ctea5764Driver_tune end\n");)
	return true;
}


/*---------------------------------------------------------------------------------------
			Seek׵
			ȿϻߤޤ
			ߤμȿ饵Τ߻ꤹ
----------------------------------------------------------------------------------------*/
#define RDS_SEEKCTRL_GETFREQ_SIZE 8
#define RDS_SEEKCTRL_SIZE 5
#define TEAMSG_SEEK(a)
bool Ctea5764Driver_Seek(unsigned char SearchFlag,unsigned char bLevelLimit)
{
	long dwExecSendSize;
	unsigned long fr;
	unsigned long pll;
	//SeekλåäƤ
//	Ctea5764Driver_CheckSeekEndFlag();
	TEAMSG_SEEK(printk(KERN_EMERG "Ctea5764Driver_Seek start\n");)
	if (pI2CForm == NULL) {
		return false;
	}

	fr = Ctea5764Driver_MakeFreq(Tea5764ReadData.buff[6] & 0x3f,Tea5764ReadData.buff[7] & 0xff);
//	RETAILMSG(1, (TEXT("Seek start1 pll 0x%X 0x%X\r\n"),Tea5764ReadData.buff[6],Tea5764ReadData.buff[7]));
	TEAMSG_SEEK(printk(KERN_EMERG "Seek start1 pll 0x%X 0x%X\r\n",Tea5764ReadData.buff[6],Tea5764ReadData.buff[7]);)
	if (SearchFlag == TMC_RDS_SEEK_UP) {
		if ((fr+1) <= TMCRDS_USEU_FMBAND_LIMIT_MAX) {
			fr = fr +1;
		} else {
			fr = TMCRDS_USEU_FMBAND_LIMIT_MIN;
		}
		pll = Ctea5764Driver_MakePLL(fr);
		Tea5764WriteData.buff[1] = (unsigned char)((pll >> 8) & 0x0000003f);		//PLL hight byte
		Tea5764WriteData.buff[2] = (unsigned char)(pll & 0x000000ff);		//PLL Low byte
//	RETAILMSG(1, (TEXT("Seek start up pll 0x%X 0x%X\r\n"),Tea5764WriteData.buff[1],Tea5764WriteData.buff[2]));
	TEAMSG_SEEK(printk(KERN_EMERG "Seek start up pll Freq %d 0x%X 0x%X\r\n",fr,Tea5764WriteData.buff[1],Tea5764WriteData.buff[2]);)
		if (hlsi) {
			Tea5764WriteData.buff[4] |= TEA5764_TNCTRL2_HLSI;
		} else {
			Tea5764WriteData.buff[4] &= ~TEA5764_TNCTRL2_HLSI;
		}
		Tea5764WriteData.buff[1] |= TEA5764_FRQSETM_SUD;
	} else {
		if ((fr-1) >= TMCRDS_USEU_FMBAND_LIMIT_MIN) {
			fr = fr -1;
		} else {
			fr = TMCRDS_USEU_FMBAND_LIMIT_MAX;
		}
		pll = Ctea5764Driver_MakePLL(fr);
		Tea5764WriteData.buff[1] = (unsigned char)((pll >> 8) & 0x0000003f);		//PLL hight byte
		Tea5764WriteData.buff[2] = (unsigned char)(pll & 0x000000ff);		//PLL Low byte
//	RETAILMSG(1, (TEXT("Seek start down pll 0x%X 0x%X\r\n"),Tea5764WriteData.buff[1],Tea5764WriteData.buff[2]));
		TEAMSG_SEEK(printk(KERN_EMERG "Seek start down pll Freq %d 0x%X 0x%X\r\n",fr,Tea5764WriteData.buff[1],Tea5764WriteData.buff[2]);)
		if (hlsi) {
			Tea5764WriteData.buff[4] |= TEA5764_TNCTRL2_HLSI;
		} else {
			Tea5764WriteData.buff[4] &= ~TEA5764_TNCTRL2_HLSI;
		}
		Tea5764WriteData.buff[1] &= ~TEA5764_FRQSETM_SUD;
	}
	//LevelLimit
	Tea5764WriteData.buff[4] &= ~TEA5764_TNCTRL2_SS;
		switch(bLevelLimit) {
		case RDS_SEARCH_LEVEL_LIMIT3:
			Tea5764WriteData.buff[4] |= TEA5764_TNCTRL2_SS_ADC3;
			break;
		case RDS_SEARCH_LEVEL_LIMIT5:
			Tea5764WriteData.buff[4] |= TEA5764_TNCTRL2_SS_ADC5;
			break;
		case RDS_SEARCH_LEVEL_LIMIT7:
			Tea5764WriteData.buff[4] |= TEA5764_TNCTRL2_SS_ADC7;
			break;
		case RDS_SEARCH_LEVEL_LIMIT10:
			Tea5764WriteData.buff[4] |= TEA5764_TNCTRL2_SS_ADC10;
			break;
		default:
			Tea5764WriteData.buff[4] |= TEA5764_TNCTRL2_SS_ADC5;
			break;
		}

	//Search Modeѹ
	Tea5764WriteData.buff[1] |= TEA5764_FRQSETM_SM;
	//FRRFLAGΩľ
	Tea5764WriteData.buff[0] |= (TEA5764_INTMASK_FRMSK | TEA5764_INTMASK_BLMSK | TEA5764_INTMASK_IFMSK);
	//IF Connect count 15ms 
	Tea5764WriteData.buff[3]  |= TEA5764_TNCTRL1_IFCTC;			/* 15ms*/
	if(!(pI2CForm->i2c_send)((unsigned char)((TEA5764_TUNE_FM_MODE << 1) & ~TEA5764_RW_BIT), 
		(char *)Tea5764WriteData.buff, RDS_SEEKCTRL_SIZE,&dwExecSendSize)){
		return false;
	}
	if (dwExecSendSize != RDS_SEEKCTRL_SIZE) {
		return FALSE;
	}
	TEAMSG_SEEK(printk(KERN_EMERG "Ctea5764Driver_Seek end\n");)
	return true;
}

/*---------------------------------------------------------------------------------------
			쥸ͤɤ߽Ф
----------------------------------------------------------------------------------------*/
#ifdef WINCE
void Ctea5764Driver_get_allreg(  PBYTE pBufOut,DWORD dwLenOut,PDWORD pdwActualOut)
#else
void Ctea5764Driver_get_allreg(char *pBufOut,long dwLenOut,long *pdwActualOut)
#endif
{
	unsigned long dwSendSize;
	long dwExecSendSize = 0;
//	int loop = 0;
	EXEC_DEBMSG(printk("Ctea5764Driver_get_allreg 1 %d\n",(int)dwLenOut);)
	if (pI2CForm == NULL) {
		*pdwActualOut = 0;
		return;
	}
	if (dwLenOut > 28) {
		dwSendSize = 28;
	} else {
		dwSendSize = dwLenOut;
	}
	if(!(pI2CForm->i2c_recv)((unsigned char)((TEA5764_TUNE_FM_MODE << 1) | TEA5764_RW_BIT),
		(char *)Tea5764ReadData.buff, dwSendSize,&dwExecSendSize)) {
		*pdwActualOut = 0;
	} else {
		if(dwExecSendSize > 28) {
			*pdwActualOut = 28;
		} else {
			if (dwExecSendSize >= 0){ 
				*pdwActualOut = dwExecSendSize;
			} else {
				*pdwActualOut = 0;
			}
		}
		memcpy(pBufOut,Tea5764ReadData.buff,*pdwActualOut);
#if 0
		for(loop = 0;loop < *pdwActualOut;loop++){
		EXEC_DEBMSG(printk("Ctea5764Driver_get_allreg reg%d 0x%X\n",loop,pBufOut[loop]);)
		}
#endif
	}
	EXEC_DEBMSG(printk("Ctea5764Driver_get_allreg 5\n");)
	Ctea5764Driver_EnableInt(TRUE);
}

/*---------------------------------------------------------------------------------------
			
			TEA5764ϴŪMASKɤMASKꥢ
			ʤΤǡReadꤵƤMASKꤹɬפ
----------------------------------------------------------------------------------------*/
#define RDS_INTCTRL_SIZE 1
BOOL Ctea5764Driver_EnableInt(bool on) {
	long dwExecSendSize;
	unsigned long WriteSize = RDS_INTCTRL_SIZE;
	//Mask
	if (on == TRUE) {
	} else {
	Tea5764WriteData.buff[0] &= ~(TEA5764_INTMASK_DAVMSK | TEA5764_INTMASK_LSYMSK | TEA5764_INTMASK_IFMSK |
								TEA5764_INTMASK_LEVMSK | TEA5764_INTMASK_PDMSK | TEA5764_INTMASK_FRMSK | TEA5764_INTMASK_BLMSK);
	}
//	DEBUGMSG(1, (TEXT("------- Ctea5764Driver_EnableInt ------- 0x%X 0x%X\r\n"),Tea5764WriteData.buff[0],Tea5764WriteData.buff[1]));
	if (pI2CForm == NULL) {
		return false;
	}
	if (m_SwPortWriteFlag == true) {
		WriteSize = RDS_SWPORT_SIZE;
		if(!(pI2CForm->i2c_send)((unsigned char)((TEA5764_TUNE_FM_MODE << 1) & ~TEA5764_RW_BIT),
			(char *)Tea5764WriteData.buff, WriteSize,&dwExecSendSize)) {
			return FALSE;
		}
		m_SwPortWriteFlag = false;
		//SendEventƤӤɡĸƤФʤƤɤˤʤϤ
	} else {
		if(!(pI2CForm->i2c_send)((unsigned char)((TEA5764_TUNE_FM_MODE << 1) & ~TEA5764_RW_BIT),
			(char *)Tea5764WriteData.buff, WriteSize,&dwExecSendSize)){
			return false;
		}
	}
	if (dwExecSendSize != RDS_INTCTRL_SIZE) {
		return FALSE;
	}
	return TRUE;
}
#define DEBMSG_SWP(a)
/*---------------------------------------------------------------------------------------
			NAVI-ATTSWPortå
			̾ϳߥե饰κǹԤ뤬ݸδƻ륹åɤƤФ
----------------------------------------------------------------------------------------*/
bool Ctea5764CheckSwPort(void)
{
	long dwExecSendSize;
	DEBMSG_SWP(printk("Ctea5764CheckSwPort\n");)
	if (m_SwPortWriteFlag == true) {
	DEBMSG_SWP(printk("Ctea5764CheckSwPort write1\n");)
		if (pI2CForm == NULL) {
			return false;
		}
	DEBMSG_SWP(printk("Ctea5764CheckSwPort write2\n");)
		if(!(pI2CForm->i2c_send)((unsigned char)((TEA5764_TUNE_FM_MODE << 1) & ~TEA5764_RW_BIT),
			(char *)Tea5764WriteData.buff, RDS_SWPORT_SIZE,&dwExecSendSize)) {
			return false;
		}
		m_SwPortWriteFlag = false;
//		RETAILMSG(1, (TEXT("*@@*\r\n")));
	}
	DEBMSG_SWP(printk("Ctea5764CheckSwPort end\n");)
	return true;
}

/*---------------------------------------------------------------------------------------
			DAV
----------------------------------------------------------------------------------------*/
bool Ctea5764Driver_DavIntCtrl(bool on)
{
	unsigned char mask = Tea5764WriteData.buff[0];
	//DAV ߺ
	if (on == TRUE) {
//		if ((Tea5764WriteData.buff[0] & TEA5764_INTMASK_DAVMSK) != TEA5764_INTMASK_DAVMSK)  {
			Tea5764WriteData.buff[0] |= TEA5764_INTMASK_DAVMSK;
			if(!Ctea5764Driver_EnableInt(TRUE)) {
				if(!Ctea5764Driver_EnableInt(TRUE)) {
					//ߥޥ򸵤᤹
					Tea5764WriteData.buff[0] = mask;
					return false;
				}
			}
//		}
	} else {
		Tea5764WriteData.buff[0] &= ~TEA5764_INTMASK_DAVMSK;
		if (!Ctea5764Driver_EnableInt(TRUE)) {
			//Ԥ⤦ꤹ
			if (!Ctea5764Driver_EnableInt(TRUE)) {
				Tea5764WriteData.buff[0] = mask;
				return false;
			}
		}
	}
	return true;
}

/*---------------------------------------------------------------------------------------
			ȿϳߤDisable
----------------------------------------------------------------------------------------*/
bool Ctea5764Driver_SeekIntDisable(void)
{
	long dwExecSendSize;
	Tea5764WriteData.buff[0] &= ~(TEA5764_INTMASK_IFMSK | TEA5764_INTMASK_FRMSK | TEA5764_INTMASK_BLMSK);
	if (pI2CForm == NULL) {
		return false;
	}
	if(!(pI2CForm->i2c_send)((unsigned char)((TEA5764_TUNE_FM_MODE << 1) & ~TEA5764_RW_BIT),
		(char *)Tea5764WriteData.buff, RDS_INTCTRL_SIZE,&dwExecSendSize)){
		return false;
	}
	if (dwExecSendSize != RDS_INTCTRL_SIZE) {
		return FALSE;
	}
	return TRUE;

}

/*---------------------------------------------------------------------------------------
			ȿPLLѴؿ
			ϡ100KHzñ̡98MHz=980
			ϡPPL
----------------------------------------------------------------------------------------*/
//Ϥ100KHzñ98MHz=980
unsigned long Ctea5764Driver_MakePLL(int freq)
{
	//kHzǷ׻ƺǸHz᤹
	unsigned long n = freq * 100UL;	//ȿ kHz
	n += hlsi ? 225 : -225;				//f IF
	//(4*n*1000)/32768 = (n+1000)/8192
	n = n * 1000UL / 8192;
	if (freq == -1) {
		RETAILMSG(1, (TEXT("PPL -1 %d\r\n"),n));
	}
	return n;
}

/*---------------------------------------------------------------------------------------
			PLL>freqѴ
----------------------------------------------------------------------------------------*/
unsigned long Ctea5764Driver_MakeFreq(unsigned char Pll_H,unsigned char Pll_L)
{
#ifdef FLAOT_ENABLE
	float freq;
	freq = (float)((Pll_H << 8) + Pll_L);
#else
	long freq;
	freq = (long)((Pll_H << 8) + Pll_L);
#endif
	freq *= (long)(32768 / 4);
	freq -= hlsi ? 225000 : -225000;
	freq /= 100000UL;
#ifdef FLAOT_ENABLE
	return (unsigned long)(freq+(float)hlsi);
#else
	return (unsigned long)(freq+hlsi);
#endif
	return 0;
}

/*---------------------------------------------------------------------------------------
			ѥ쥸ǡȤΩơ
			ȿѤ¸ߤƤʤ
----------------------------------------------------------------------------------------*/
void *Ctea5764Driver_construct_register(int Mode,int data)
{
	if (Mode == TEA_FREQENCY) {
		unsigned long n = data * 100UL;
		n += hlsi ? 225 : -225;
		n = 4 * n * 1000UL / 32768;

		Tea5764WriteData.FR_H = (unsigned char)((n >> 8) & 0xff);
		Tea5764WriteData.FR_L = (unsigned char)(n & 0xff);
		Tea5764WriteData.HLSI = hlsi;

		Tea5764WriteData.SM = 0;							// preset mode

//Tea5764WriteData.DAVMSK;							// RDS check
	}
	return (void *)NULL;
}

#if 0
/*---------------------------------------------------------------------------------------
			RDSǡκ¿ʬȤäƤʤ
----------------------------------------------------------------------------------------*/
void *Ctea5764Driver_construct_rds_data(int Mode,int data)
{
	if (Mode == TEA_FREQENCY) {
		unsigned long n = data * 100UL;
		n += hlsi ? 225 : -225;
		n = 4 * n * 1000UL / 32768;

		Tea5764WriteData.FR_H = (unsigned char)((n >> 8) & 0xff);
		Tea5764WriteData.FR_L = (unsigned char)(n & 0xff);
		Tea5764WriteData.HLSI = hlsi;

		Tea5764WriteData.SM = 0;							// preset mode

//Tea5764WriteData.DAVMSK;							// RDS check
	}

	return (void *)NULL;
}
#endif
/*---------------------------------------------------------------------------------------
			ѤΥ쥸
----------------------------------------------------------------------------------------*/
void Ctea5764Driver_MakeInitData(void)
{
	/* 0W 0xbf*/
	Tea5764WriteData.buff[0] = 0x00;					/* clear all flags */

	/* 1W 0x00*/
	Tea5764WriteData.buff[1] = 0x29;					// preset&87.5Mhz(0x29d4)

	/* 2W 0x00*/
	Tea5764WriteData.buff[2] = 0xd4;					// 87.5Mhz(0x29d4)

	/* 3W 0xC9*/
	Tea5764WriteData.PUPD   = 3;						/* 0: all off */
	Tea5764WriteData.BLIM   = 0;						/* 0: US/EUR */
	Tea5764WriteData.SWPM   = 0;						/* 0: SWP */
	Tea5764WriteData.IFCTC  = 1;						/* 1: 15ms*/
	Tea5764WriteData.AFM    = 0;						/* 0: audio mute off */
	Tea5764WriteData.SMUTE  = 0;						/* 0: soft mute off */
	Tea5764WriteData.SNC    = 1;						/* 1: stereo noise cancellation on */

	/* 4W 0x22*/
	Tea5764WriteData.MU     = 0;						/* 0: hard mute off */
	Tea5764WriteData.SS     = 1;						/* 1: serch stop level ADC5 */
	Tea5764WriteData.HLSI   = 1;						/* 1: hight-side injection */
	Tea5764WriteData.MST    = 0;						/* 0: stereo on */
	Tea5764WriteData.SWP    = 0;						/* 0: default low */
	Tea5764WriteData.DTC    = 1;						/* 1: 50us de-emphasis */
	Tea5764WriteData.AHLSI  = 0;						/* 0: Auto H/L injection stop off */

	/* 5W 0x02*/
	Tea5764WriteData.LHM    = 0;						/* 0: left audio hard mute off */
	Tea5764WriteData.RHM    = 0;						/* 0: right audio hard mute off */
	Tea5764WriteData.RDSCDA = 0;						/* 0: VAFL/VAFR is audio output */
	Tea5764WriteData.LHSW   = 0;						/* level hysteresis is small */
	Tea5764WriteData.TRIGFR = 0;						/* crystal as reference pin XTAL */
	Tea5764WriteData.LDX    = 0;						/* 0: local DX off */
	Tea5764WriteData.RFAGC  = 1;						/* 1: RF AGC off */
	Tea5764WriteData.INTCTRL= 0;						/* 0: INT CTL generated */

	/* 6W 0x00*/
	Tea5764WriteData.TM     = 0;						/* 0: normal operation */
	Tea5764WriteData.TB     = 0;

	/* 7W 0x40*/
	Tea5764WriteData.NWSY   = 0;						/* 0:normal processing */
	Tea5764WriteData.SYM    = 2;						/* 2:error correction maximum 5bit */
	Tea5764WriteData.RBDS   = 0;						/* 0:RDS processing mode */
	Tea5764WriteData.DAC    = 0;						/* 0:RDS data output mode DAVA */

	/* 8W 0x10*/
	Tea5764WriteData.buff[8] = 0x10;
	/* 9W 0x00*/
	Tea5764WriteData.buff[9] = 0x00;
	/* 10W 0x00*/
	Tea5764WriteData.buff[10] = 0x00;

}

/*---------------------------------------------------------------------------------------
			ѤΥ쥸
----------------------------------------------------------------------------------------*/
void Ctea5764Driver_MakeInitData2nd(void)
{
	/* 0W 0xbf*/
	Tea5764WriteData.buff[0] = 0x00;					/* clear all flags */

	/* 1W 0x00*/
	Tea5764WriteData.buff[1] = 0x29;					// preset&87.5Mhz(0x29d4)

	/* 2W 0x00*/
	Tea5764WriteData.buff[2] = 0xd4;					// 87.5Mhz(0x29d4)

	/* 3W 0xC9*/
	Tea5764WriteData.PUPD   = 3;						/* 0: all off */
	Tea5764WriteData.BLIM   = 0;						/* 0: US/EUR */
	Tea5764WriteData.SWPM   = 0;						/* 0: SWP */
	Tea5764WriteData.IFCTC  = 1;						/* 1: 15ms*/
	Tea5764WriteData.AFM    = 0;						/* 0: audio mute off */
	Tea5764WriteData.SMUTE  = 0;						/* 0: soft mute off */
	Tea5764WriteData.SNC    = 1;						/* 1: stereo noise cancellation on */

	/* 4W 0x22*/
	Tea5764WriteData.MU     = 0;						/* 0: hard mute off */
	Tea5764WriteData.SS     = 1;						/* 1: serch stop level ADC5 */
	Tea5764WriteData.HLSI   = 1;						/* 1: hight-side injection */
	Tea5764WriteData.MST    = 0;						/* 0: stereo on */
//	Tea5764WriteData.SWP    = 0;						/* 0: default low */
	Tea5764WriteData.SWP    = Tea5764ReadData.SWP;		/* 0: default low */
	Tea5764WriteData.DTC    = 1;						/* 1: 50us de-emphasis */
	Tea5764WriteData.AHLSI  = 0;						/* 0: Auto H/L injection stop off */

	/* 5W 0x02*/
	Tea5764WriteData.LHM    = 0;						/* 0: left audio hard mute off */
	Tea5764WriteData.RHM    = 0;						/* 0: right audio hard mute off */
	Tea5764WriteData.RDSCDA = 0;						/* 0: VAFL/VAFR is audio output */
	Tea5764WriteData.LHSW   = 0;						/* level hysteresis is small */
	Tea5764WriteData.TRIGFR = 0;						/* crystal as reference pin XTAL */
	Tea5764WriteData.LDX    = 0;						/* 0: local DX off */
	Tea5764WriteData.RFAGC  = 1;						/* 1: RF AGC off */
	Tea5764WriteData.INTCTRL= 0;						/* 0: INT CTL generated */

	/* 6W 0x00*/
	Tea5764WriteData.TM     = 0;						/* 0: normal operation */
	Tea5764WriteData.TB     = 0;

	/* 7W 0x40*/
	Tea5764WriteData.NWSY   = 0;						/* 0:normal processing */
	Tea5764WriteData.SYM    = 2;						/* 2:error correction maximum 5bit */
	Tea5764WriteData.RBDS   = 0;						/* 0:RDS processing mode */
	Tea5764WriteData.DAC    = 0;						/* 0:RDS data output mode DAVA */

	/* 8W 0x10*/
	Tea5764WriteData.buff[8] = 0x10;
	/* 9W 0x00*/
	Tea5764WriteData.buff[9] = 0x00;
	/* 10W 0x00*/
	Tea5764WriteData.buff[10] = 0x00;

}

/*---------------------------------------------------------------------------------------
			ѤΥ쥸
----------------------------------------------------------------------------------------*/
void Ctea5764Driver_MakeReInitData(void)
{
	//ʤ褦ˤƤ
	/* 0W 0xbf*/
//	Tea5764WriteData.buff[0] = 0x00;					/* clear all flags */
	//SearchModeˤʤäƤΤ⤪ΤPresetModeˤƤ
	/* 1W */
//	Tea5764WriteData.buff[1] &= ~TEA5764_FRQSETM_SM;	// preset Mode
	//ʲϤΤޤ
	/* 2W */
	/* 3W */
	Tea5764WriteData.SWPM   = 0;						/* 0: SWP */
	Tea5764WriteData.SWP   = 0;						/* 0: SWP */
	/* 4W */
	/* 5W */
	/* 6W */
	Tea5764WriteData.buff[6] = 0;
	/* 7W */
	/* 8W */
	/* 9W */
	/* 10W */

}

/*---------------------------------------------------------------------------------------
			ǥɴ
----------------------------------------------------------------------------------------*/
long Ctea5764Driver_getError(void)
{
	static long error = 0;
#if 0
	long dwExecSendSize;

	if (pI2CForm == NULL) {
		return error;
	}
	if(!(pI2CForm->i2c_recv)((unsigned char)((TEA5764_TUNE_FM_MODE << 1) | TEA5764_RW_BIT),
		(char *)Tea5764ReadData.TU_BUFF, 1,&dwExecSendSize)) {
		return error;
	}
	if (Tea5764ReadData.DAVFLG) {
		if(!(pI2CForm->i2c_recv)((unsigned char)((TEA5764_TUNE_RDS_MODE << 1) | TEA5764_RW_BIT),
			(char *)Tea5764ReadData.RD_BUFF, 8,&dwExecSendSize)) {
			return error;
		}
		error = (error * 99 + !Tea5764ReadData.ELB) / 100;
	}
	Ctea5764Driver_EnableInt(TRUE);
#endif
	return error;
}


/*---------------------------------------------------------------------------------------
			DAVե饰å
----------------------------------------------------------------------------------------*/
bool Ctea5764Driver_CheckDAVFlag(void)
{
	long dwExecReadSzie;

	//DAVߵĤɤå
	if (
		(Tea5764WriteData.buff[0] & TEA5764_INTMASK_DAVMSK) == TEA5764_INTMASK_DAVMSK
		) {
		//Ƥ֤ȤR0ɤ߹ߺѤߤʤΤǥե饰å
		if ((Tea5764ReadData.buff[0] & TEA_INTFLAG_DAVFLG) == TEA_INTFLAG_DAVFLG) {
			DEBMSG(RETAILMSG(1, (TEXT("Lev DAV\r\n")));)
			//٥Ȥɤ߽ФƬɤ߽Ф
			if (pI2CForm == NULL) {
				return false;
			}
#ifdef TMC_ALL_DATA
			if(!(pI2CForm->i2c_recv)((unsigned char)((TEA5764_TUNE_RDS_MODE << 1) | TEA5764_RW_BIT),
				(char *)&(Tea5764ReadData.buff[12]),12,&dwExecReadSzie)){
				return false;
			}
#else
			if(!(pI2CForm->i2c_recv)((unsigned char)((TEA5764_TUNE_RDS_MODE << 1) | TEA5764_RW_BIT),
				(char *)&(Tea5764ReadData.buff[12]),8,&dwExecReadSzie)){
				return false;
			}
#endif

			(pIRDSListener->update_rds_data)(2,&(Tea5764ReadData.buff[0]),12);
		}
		//ꤹߤκ
		Tea5764WriteData.buff[0] |= TEA5764_INTMASK_DAVMSK;
	}
	return TRUE;
}
/*---------------------------------------------------------------------------------------
			ǥɴ
----------------------------------------------------------------------------------------*/
void Ctea5764Driver_CheckSeekEndFlag(void)
{
	if (
		((Tea5764ReadData.buff[0] & TEA_INTFLAG_IFFLAG) != TEA_INTFLAG_IFFLAG) &&
		((Tea5764ReadData.buff[0] & TEA_INTFLAG_BLFLAG) != TEA_INTFLAG_BLFLAG) &&
		((Tea5764ReadData.buff[0] & TEA_INTFLAG_FRRFLAG) == TEA_INTFLAG_FRRFLAG)
	){
			//ͥ븫ĤäorץꥻåḫĤä
			if ((Tea5764WriteData.buff[1] & TEA5764_FRQSETM_SM) == TEA5764_FRQSETM_SM) {
#ifdef SLEEP_ON
#ifdef WINCE
			Sleep(15);
#else
//			mdelay(15);
#endif
#endif
				//ꤹߤκ
				Tea5764WriteData.buff[0] &= ~(TEA_INTFLAG_FRRFLAG | TEA5764_INTMASK_BLMSK | TEA5764_INTMASK_IFMSK);
				Tea5764WriteData.buff[1] = (unsigned char)(Tea5764ReadData.buff[6] & 0x3f);		//PLL hight byte
				Tea5764WriteData.buff[2] = (unsigned char)(Tea5764ReadData.buff[7] & 0xff);			//PLL Low byte
				Tea5764WriteData.buff[1] &= ~TEA5764_FRQSETM_SM;
				if (pIRDSListener != NULL) {
					(pIRDSListener->update_rds_data)(0,NULL,0);
				}

				DEBMSG(RETAILMSG(1, (TEXT("------- SEEK End1------- \r\n")));)
			} else {
				Tea5764WriteData.buff[0] &= ~TEA5764_INTMASK_FRMSK;
				if (pIRDSListener != NULL) {
					(pIRDSListener->update_rds_data)(3,NULL,0);
				}
				DEBMSG(RETAILMSG(1, (TEXT("------- Preset End1------- \r\n")));)
			}


	//ͥ븫ĤäƥХɥߥåȤˤʤäå
	} else if(
		((Tea5764ReadData.buff[0] & TEA_INTFLAG_IFFLAG) != TEA_INTFLAG_IFFLAG) &&
		((Tea5764ReadData.buff[0] & TEA_INTFLAG_BLFLAG) == TEA_INTFLAG_BLFLAG) &&
		((Tea5764ReadData.buff[0] & TEA_INTFLAG_FRRFLAG) == TEA_INTFLAG_FRRFLAG)
	){
		//SM=1 Search Modeʤ
		if ((Tea5764WriteData.buff[1] & TEA5764_FRQSETM_SM) == TEA5764_FRQSETM_SM) {
			DEBMSG(RETAILMSG(1, (TEXT("------- SEEK End2------- \r\n")));)
			//ͥ븫ĤäƥХɥߥåȤˤʤäḫĤä
			if (pIRDSListener != NULL) {
				(pIRDSListener->update_rds_data)(0,NULL,0);
			}
			//ꤹߤκ
			Tea5764WriteData.buff[0] &= ~(TEA5764_INTMASK_FRMSK | TEA5764_INTMASK_BLMSK | TEA5764_INTMASK_IFMSK);
			Tea5764WriteData.buff[1] = (unsigned char)(Tea5764ReadData.buff[6] & 0x3f);		//PLL hight byte
			Tea5764WriteData.buff[2] = (unsigned char)(Tea5764ReadData.buff[7] & 0xff);			//PLL Low byte
			Tea5764WriteData.buff[1] &= ~TEA5764_FRQSETM_SM;
		}
		//ꤹߤκ
		Tea5764WriteData.buff[0] &= ~(TEA5764_INTMASK_FRMSK | TEA5764_INTMASK_BLMSK | TEA5764_INTMASK_IFMSK);

	//ͥ븫ĤäͭRSSI٥뤢뤱ɡ
	} else if(
		((Tea5764ReadData.buff[0] & TEA_INTFLAG_IFFLAG) == TEA_INTFLAG_IFFLAG) &&
		((Tea5764ReadData.buff[0] & TEA_INTFLAG_BLFLAG) != TEA_INTFLAG_BLFLAG) &&
		((Tea5764ReadData.buff[0] & TEA_INTFLAG_FRRFLAG) == TEA_INTFLAG_FRRFLAG)
	){
		//Preset orSearch ModeɤǤOK
		if ((Tea5764WriteData.buff[1] & TEA5764_FRQSETM_SM) == TEA5764_FRQSETM_SM) {
			//ͥ븫ĤäͭRSSI٥뤢뤱ɡԡḫĤä
			DEBMSG(RETAILMSG(1, (TEXT("------- SEEK End3------- \r\n")));)
			if (pIRDSListener != NULL) {
				(pIRDSListener->update_rds_data)(0,NULL,0);
			}
			//ꤹߤκ
			Tea5764WriteData.buff[0] &= ~(TEA5764_INTMASK_FRMSK | TEA5764_INTMASK_BLMSK | TEA5764_INTMASK_IFMSK);
			Tea5764WriteData.buff[1] = (unsigned char)(Tea5764ReadData.buff[6] & 0x3f);		//PLL hight byte
			Tea5764WriteData.buff[2] = (unsigned char)(Tea5764ReadData.buff[7] & 0xff);			//PLL Low byte
			Tea5764WriteData.buff[1] &= ~TEA5764_FRQSETM_SM;

		} else if ((Tea5764WriteData.buff[1] & TEA5764_FRQSETM_SM) != TEA5764_FRQSETM_SM) {
			Tea5764WriteData.buff[0] &= ~TEA5764_INTMASK_FRMSK;
			if (pIRDSListener != NULL) {
				(pIRDSListener->update_rds_data)(3,NULL,0);
			}
			DEBMSG(RETAILMSG(1, (TEXT("------- Preset End2------- \r\n")));)
		} else if ((Tea5764ReadData.buff[0] & TEA_INTFLAG_LSYNCFL) == TEA_INTFLAG_LSYNCFL) {
//			Tea5764WriteData.buff[1] &= ~TEA5764_FRQSETM_SM;
//			Tea5764WriteData.buff[7]  &= TEA5764_RDSCTRL_NWSY;			/* */
//			(pI2CForm->i2c_send)((unsigned char)((TEA5764_TUNE_FM_MODE << 1) & ~TEA5764_RW_BIT), (char *)Tea5764WriteData.buff, 7,&dwExecReadSzie);
		}
		//ꤹߤκ
		Tea5764WriteData.buff[0] &= ~(TEA5764_INTMASK_FRMSK | TEA5764_INTMASK_BLMSK | TEA5764_INTMASK_IFMSK);

	//ĤʤޤޥߥåȤˤʤä
	} else if(
		((Tea5764ReadData.buff[0] & TEA_INTFLAG_IFFLAG) == TEA_INTFLAG_IFFLAG) &&
		((Tea5764ReadData.buff[0] & TEA_INTFLAG_BLFLAG) == TEA_INTFLAG_BLFLAG) &&
		((Tea5764ReadData.buff[0] & TEA_INTFLAG_FRRFLAG) == TEA_INTFLAG_FRRFLAG)
	){
		//ꤹߤκ
		Tea5764WriteData.buff[0] &= ~(TEA5764_INTMASK_FRMSK | TEA5764_INTMASK_BLMSK | TEA5764_INTMASK_IFMSK);
		//SM=1 Search Modeʤ
		if ((Tea5764WriteData.buff[1] & TEA5764_FRQSETM_SM) == TEA5764_FRQSETM_SM) {
			//ĤʤޤޥߥåȤˤʤä
			DEBMSG(RETAILMSG(1, (TEXT("------- SEEK End4------- \r\n")));)
			//ꤹߤκ
			Tea5764WriteData.buff[0] &= ~(TEA5764_INTMASK_FRMSK | TEA5764_INTMASK_BLMSK | TEA5764_INTMASK_IFMSK);
			Tea5764WriteData.buff[1] = (unsigned char)(Tea5764ReadData.buff[6] & 0x3f);		//PLL hight byte
			Tea5764WriteData.buff[2] = (unsigned char)(Tea5764ReadData.buff[7] & 0xff);			//PLL Low byte
			Tea5764WriteData.buff[1] &= ~TEA5764_FRQSETM_SM;
			if (pIRDSListener != NULL) {
				(pIRDSListener->update_rds_data)(1,NULL,0);
			}
		}
	}
}
/*---------------------------------------------------------------------------------------
			Ÿ

----------------------------------------------------------------------------------------*/
#define RDS_POWERCTRL_SIZE 4
void Ctea5764Driver_setPower(bool on) {
	long dwExecSendSize;
	Tea5764WriteData.PUPD = 3;
	if (pI2CForm == NULL) {
		return;
	}
	(pI2CForm->i2c_send)((unsigned char)((TEA5764_TUNE_FM_MODE << 1) & ~TEA5764_RW_BIT), 
				(char *)Tea5764WriteData.buff, RDS_POWERCTRL_SIZE,&dwExecSendSize);
	if (dwExecSendSize != RDS_POWERCTRL_SIZE) {
	}
}
/*---------------------------------------------------------------------------------------
			SW Port

----------------------------------------------------------------------------------------*/
bool Ctea5764Driver_set_SWPort(bool Flag)
{
//	unsigned long dwExecSendSize;
	Tea5764WriteData.buff[3] &= ~TEA5764_TNCTRL1_SWPM;
	if (Flag == true) {
//		RETAILMSG(1, (TEXT("SW 1\r\n")));
		Tea5764WriteData.buff[4] |= TEA5764_TNCTRL2_SWP;
	} else {
//		RETAILMSG(1, (TEXT("SW 0\r\n")));
		Tea5764WriteData.buff[4] &= ~TEA5764_TNCTRL2_SWP;
	}
	m_SwPortWriteFlag = true;
//	(pI2CForm->i2c_send)((unsigned char)((TEA5764_TUNE_FM_MODE << 1) & ~TEA5764_RW_BIT), 
//				(char *)Tea5764WriteData.buff, RDS_SWPORT_SIZE,&dwExecSendSize);
//	if (dwExecSendSize != RDS_SWPORT_SIZE) {
//		return false;
//	}
	return true;

}
bool Ctea5764Driver_get_SWPort(void)
{
	if ((Tea5764WriteData.buff[4] & TEA5764_TNCTRL2_SWP) == TEA5764_TNCTRL2_SWP) {
		return true;
	} else {
		return false;
	}
}

void Ctea5764Driver_SetFRMaskOff(void)
{
	long dwExecSendSize = 0;
	Tea5764WriteData.buff[0] &= ~TEA5764_INTMASK_FRMSK;
	(pI2CForm->i2c_send)((unsigned char)((TEA5764_TUNE_FM_MODE << 1) & ~TEA5764_RW_BIT), 
				(char *)Tea5764WriteData.buff, 1,&dwExecSendSize);
}

