#ifndef TEA5764HN_H
#define TEA5764HN_H


/****************************************************************
 *
 * Byte description (see 11.4)
 *
 */
#ifdef WIN32
#define ATTR_PACKED
#else
#define ATTR_PACKED __attribute((packed))
#endif //#ifdef WIN32

#pragma pack(1)
typedef union _INTFLAG {				/*** 0R ***/
  unsigned char byte;
  struct {
	unsigned char _blflag :1;
	unsigned char _frrflag:1;
	unsigned char _pdflag :1;
	unsigned char _levflag:1;
	unsigned char _ifflag :1;
	unsigned char _lsyncfl:1;
	unsigned char _testbit:1;
	unsigned char _davflg :1;
  } s ;
}_INTFLAG;

typedef union _INTMSK {					/*** 1R/0W ***/
  unsigned char byte;
  struct {
	unsigned char _blmsk  :1;
	unsigned char _frmsk  :1;
	unsigned char _pdmsk  :1;
	unsigned char _levmsk :1;
	unsigned char _ifmsk  :1;
	unsigned char _lsymsk :1;
	unsigned char         :1;
	unsigned char _davmsk :1;
  } s;
} _INTMSK;

typedef union _FRQSETMSB {				/*** 2R/1W ***/
  unsigned char byte;
  struct {
	unsigned char _fr     :6;
	unsigned char _sm     :1;
	unsigned char _sud    :1;
  } s;
} _FRQSETMSB;

typedef union _FRQSETLSB {				/*** 3R/2W ***/
  unsigned char byte;
  struct {
	unsigned char _fr     :8;
  } s;
} _FRQSETLSB;

typedef union _TNCTRL1 {				/*** 4R/3W ***/
  unsigned char byte;
  struct {
	unsigned char _snc    :1;
	unsigned char _smute  :1;
	unsigned char _afm    :1;
	unsigned char _ifctc  :1;
	unsigned char _swpm   :1;
	unsigned char _blim   :1;
	unsigned char _pupd   :2;
  } s;
} _TNCTRL1;

typedef union _TNCTRL2 {				/*** 5R/4W ***/
  unsigned char byte;
  struct {
	unsigned char _ahlsi  :1;
	unsigned char _dtc    :1;
	unsigned char _swp    :1;
	unsigned char _mst    :1;
	unsigned char _hlsi   :1;
	unsigned char _ss     :2;
	unsigned char _mu     :1;
  } s;
} _TNCTRL2;

typedef union _FRQCHKMSB {				/*** 6R ***/
  unsigned char byte;
  struct {
	unsigned char _pll    :6;
	unsigned char         :2;
  } s;
} _FRQCHKMSB;

typedef union _FRQCHKLSB {				/*** 7R ***/
  unsigned char byte;
  struct {
	unsigned char _pll    :8;
  } s;
} _FRQCHKLSB;

typedef union _IFCHK {					/*** 8R ***/
  unsigned char byte;
  struct {
	unsigned char         :1;
	unsigned char _if     :7;
  } s;
} _IFCHK;

typedef union _LEVCHK {					/*** 9R ***/
  unsigned char byte;
  struct {
	unsigned char         :2;
	unsigned char _stereo :1;
	unsigned char _ld     :1;
	unsigned char _lev    :4;
  } s;
} _LEVCHK;

typedef union _TESTBITS {				/*** 10R/5W ***/
  unsigned char byte;
  struct {
	unsigned char _intctrl:1;
	unsigned char _rfagc  :1;
	unsigned char _ldx    :1;
	unsigned char _trigfr :1;
	unsigned char _lhsw   :1;
	unsigned char _rdscda :1;
	unsigned char _rhm    :1;
	unsigned char _lhm    :1;
  } s;
} _TESTBITS;

typedef union _TESTMODE {				/*** 11R/6W ***/
  unsigned char byte;
  struct {
	unsigned char _tb     :4;
	unsigned char _tm     :1;
	unsigned char         :3;
  } s;
} _TESTMODE;

typedef union _RDSSTAT1 {				/*** 12R ***/
  unsigned char byte;
  struct {
	unsigned char _elb    :2;
	unsigned char         :2;
	unsigned char _blid   :3;
	unsigned char         :1;
  } s;
} _RDSSTAT1;

typedef union _RDSSTAT2 {				/*** 13R ***/
  unsigned char byte;
  struct {
	unsigned char _dovf   :1;
	unsigned char _rstd   :1;
	unsigned char _sync   :1;
	unsigned char _epb    :2;
	unsigned char _bpid   :3;
  } s;
} _RDSSTAT2;

typedef union _RDSLBMSB {				/*** 14R ***/
  unsigned char byte;
  struct {
	unsigned char _bl     :8;
  } s;
} _RDSLBMSB;

typedef union _RDSLBLSB {				/*** 15R ***/
  unsigned char byte;
  struct {
	unsigned char _bl     :8;
  } s;
} _RDSLBLSB;

typedef union _RDSPBMSB {				/*** 16R ***/
  unsigned char byte;
  struct {
	unsigned char _bp     :8;
  } s;
} _RDSPBMSB;

typedef union _RDSPBLSB {				/*** 17R ***/
  unsigned char byte;
  struct {
	unsigned char _bp     :8;
  } s;
} _RDSPBLSB;

typedef union _RDSBBC {					/*** 18R ***/
  unsigned char byte;
  struct {
	unsigned char _gbc    :2;
	unsigned char _bbc    :6;
  } s;
} _RDSBBC;

typedef union _RDSGBC {					/*** 19R ***/
  unsigned char byte;
  struct {
	unsigned char         :4;
	unsigned char _gbc    :4;
  } s;
} _RDSGBC;

typedef union _RDSCTRL1 {				/*** 20R/7W ***/
  unsigned char byte;
  struct {
	unsigned char         :2;
	unsigned char _dac    :2;
	unsigned char _rbds   :1;
	unsigned char _sym    :2;
	unsigned char _nwsy   :1;
  } s;
} _RDSCTRL1;

typedef union _RDSCTRL2 {				/*** 21R/8W ***/
  unsigned char byte;
  struct {
	unsigned char _bbg    :5;
	unsigned char         :3;
  } s;
} _RDSCTRL2;

typedef union _PAUSEDET {				/*** 22R/9W ***/
  unsigned char byte;
  struct {
	unsigned char _gbl    :4;
	unsigned char _pl     :2;
	unsigned char _pt     :2;
  } s;
} _PAUSEDET;

typedef union _RDSBBL {					/*** 23R/10W ***/
  unsigned char byte;
  struct {
	unsigned char _bbl    :6;
	unsigned char _gbl    :2;
  } s;
} _RDSBBL;

typedef union _MANID1 {					/*** 24R ***/
  unsigned char byte;
  struct {
	unsigned char _mainid :4;
	unsigned char _version:4;
  } s;
} _MANID1;

typedef union _MANID2 {					/*** 25R ***/
  unsigned char byte;
  struct {
	unsigned char _idav   :1;
	unsigned char _mainid :7;
  } s;
} _MANID2;

typedef union _CHIPID1 {				/*** 26R ***/
  unsigned char byte;
  struct {
	unsigned char _chipid :8;
  } s;
} _CHIPID1;

typedef union _CHIPID2 {				/*** 27R ***/
  unsigned char byte;
  struct {
	unsigned char _chipid :8;
  } s;
} _CHIPID2;


/****************************************************************
 *
 * Register map (see 11.3)
 *
 */
typedef union R_DAT {
  unsigned char buff[28];
  struct {
	unsigned char tun[12];
	unsigned char rds[16];
  } b;
  struct {
	_INTFLAG   intflag;
	_INTMSK    intmsk;
	_FRQSETMSB frqsetmsb;
	_FRQSETLSB frqsetlsb;
	_TNCTRL1   tnctrl1;
	_TNCTRL2   tnctrl2;
	_FRQCHKMSB frqchkmsb;
	_FRQCHKLSB frqchklsb;
	_IFCHK     ifchk;
	_LEVCHK    levchk;
	_TESTBITS  testbits;
	_TESTMODE  testmode;
	_RDSSTAT1  rdsstat1;
	_RDSSTAT2  rdsstat2;
	_RDSLBMSB  rdslbmsb;
	_RDSLBLSB  rdslblsb;
	_RDSPBMSB  rdspbmsb;
	_RDSPBLSB  rdspblsb;
	_RDSBBC    rdsbbc;
	_RDSGBC    rdsgbc;
	_RDSCTRL1  rdsctrl1;
	_RDSCTRL2  rdsctrl2;
	_PAUSEDET  pausedet;
	_RDSBBL    rdsbbl;
	_MANID1    manid1;
	_MANID2    manid2;
	_CHIPID1   chipid1;
	_CHIPID2   chipid2;
  } d;
} R_DAT;

typedef union W_DAT {
  unsigned char buff[11];
  struct {
	unsigned char tun[7];
	unsigned char rds[4];
  } b;
  struct {
	_INTMSK    intmsk;
	_FRQSETMSB frqsetmsb;
	_FRQSETLSB frqsetlsb;
	_TNCTRL1   tnctrl1;
	_TNCTRL2   tnctrl2;
	_TESTBITS  testbits;
	_TESTMODE  testmode;
	_RDSCTRL1  rdsctrl1;
	_RDSCTRL2  rdsctrl2;
	_PAUSEDET  pausedet;
	_RDSBBL    rdsbbl;
  } d;
} W_DAT;
#pragma pack()


/*** Хåե ***/
#define TU_BUFF   b.tun
#define RD_BUFF   b.rds

/*** Хȥ ***/
#define INTFLAG   d.intflag.byte
#define INTMSK    d.intmsk.byte
#define FRQSETMSB d.frqsetmsb.byte
#define FRQSETLSB d.frqsetlsb.byte
#define TNCTRL1   d.tnctrl1.byte
#define TNCTRL2   d.tnctrl2.byte
#define FRQCHKMSB d.frqchkmsb.byte
#define FRQCHKLSB d.frqchklsb.byte
#define IFCHK     d.ifchk.byte
#define LEVCHK    d.levchk.byte
#define TESTBITS  d.testbits.byte
#define TESTMODE  d.testmode.byte
#define RDSSTAT1  d.rdsstat1.byte
#define RDSSTAT2  d.rdsstat2.byte
#define RDSLBMSB  d.rdslbmsb.byte
#define RDSLBLSB  d.rdslblsb.byte
#define RDSPBMSB  d.rdspbmsb.byte
#define RDSPBLSB  d.rdspblsb.byte
#define RDSBBC 	  d.rdsbbc.byte
#define RDSGBC 	  d.rdsgbc.byte
#define RDSCTRL1  d.rdsctrl1.byte
#define RDSCTRL2  d.rdsctrl2.byte
#define PAUSEDET  d.pausedet.byte
#define RDSBBL 	  d.rdsbbl.byte
#define MANID1 	  d.manid1.byte
#define MANID2 	  d.manid2.byte
#define CHIPID1   d.chipid1.byte
#define CHIPID2   d.chipid2.byte


/*** ܥ륢 ***/
#define DAVFLG   d.intflag.s._davflg
#define TESTBIT  d.intflag.s._testbit
#define LSYNCFL  d.intflag.s._lsyncfl
#define IFFLAG   d.intflag.s._ifflag
#define LEVFLAG  d.intflag.s._levflag
#define PDFLAG   d.intflag.s._pdflag
#define FRRFLAG  d.intflag.s._frrflag
#define BLFLAG   d.intflag.s._blflag
#define DAVMSK   d.intmsk.s._davmsk
#define LSYMSK   d.intmsk.s._lsymsk
#define IFMSK    d.intmsk.s._ifmsk
#define LEVMSK   d.intmsk.s._levmsk
#define PDMSK    d.intmsk.s._pdmsk
#define FRMSK    d.intmsk.s._frmsk
#define BLMSK    d.intmsk.s._blmsk
#define SUD      d.frqsetmsb.s._sud
#define SM       d.frqsetmsb.s._sm
#define FR_H     d.frqsetmsb.s._fr
#define FR_L     d.frqsetlsb.s._fr
#define PUPD     d.tnctrl1.s._pupd
#define BLIM     d.tnctrl1.s._blim
#define SWPM     d.tnctrl1.s._swpm
#define IFCTC    d.tnctrl1.s._ifctc
#define AFM      d.tnctrl1.s._afm
#define SMUTE    d.tnctrl1.s._smute
#define SNC      d.tnctrl1.s._snc
#define MU       d.tnctrl2.s._mu
#define SS       d.tnctrl2.s._ss
#define HLSI     d.tnctrl2.s._hlsi
#define MST      d.tnctrl2.s._mst
#define SWP      d.tnctrl2.s._swp
#define DTC      d.tnctrl2.s._dtc
#define AHLSI    d.tnctrl2.s._ahlsi
#define PLL_H    d.frqchkmsb.s._pll
#define PLL_L    d.frqchklsb.s._pll
#define IF       d.ifchk.s._if
#define LEV      d.levchk.s._lev
#define LD       d.levchk.s._ld
#define STEREO   d.levchk.s._stereo
#define LHM      d.testbits.s._lhm
#define RHM      d.testbits.s._rhm
#define RDSCDA   d.testbits.s._rdscda
#define LHSW     d.testbits.s._lhsw
#define TRIGFR   d.testbits.s._trigfr
#define LDX      d.testbits.s._ldx
#define RFAGC    d.testbits.s._rfagc
#define INTCTRL  d.testbits.s._intctrl
#define TM       d.testmode.s._tm
#define TB       d.testmode.s._tb
#define BLID     d.rdsstat1.s._blid
#define ELB      d.rdsstat1.s._elb
#define BPID     d.rdsstat2.s._bpid
#define EPB      d.rdsstat2.s._epb
#define SYNC     d.rdsstat2.s._sync
#define RSTD     d.rdsstat2.s._rstd
#define DOVF     d.rdsstat2.s._dovf
#define BL_H     d.rdslbmsb.s._bl
#define BL_L     d.rdslblsb.s._bl
#define BP_H     d.rdspbmsb.s._bp
#define BP_L     d.rdspblsb.s._bp
#define BBC      d.rdsbbc.s._bbc
#define GBC_H    d.rdsbbc.s._gbc
#define GBC_L    d.rdsgbc.s._gbc
#define NWSY     d.rdsctrl1.s._nwsy
#define SYM      d.rdsctrl1.s._sym
#define RBDS     d.rdsctrl1.s._rbds
#define DAC      d.rdsctrl1.s._dac
#define BBG      d.rdsctrl2.s._bbg
#define PT       d.pausedet.s._pt
#define PL       d.pausedet.s._pl
#define GBL_H    d.pausedet.s._gbl
#define GBL_L    d.rdsbbl.s._gbl
#define BBL      d.rdsbbl.s._bbl
#define VERSION  d.manid1.s._version
#define MAINID_H d.manid1.s._mainid
#define MAINID_L d.manid2.s._mainid
#define IDAV     d.manid2.s._idav
#define CHIPID_H d.chipid1.s._chipid
#define CHIPID_L d.chipid2.s._chipid

//0R  INT FLAG
#define TEA_INTFLAG_DAVFLG   0x80
#define TEA_INTFLAG_TESTBIT  0x40
#define TEA_INTFLAG_LSYNCFL  0x20
#define TEA_INTFLAG_IFFLAG   0x10
#define TEA_INTFLAG_LEVFLAG  0x08
#define TEA_INTFLAG_PDFLAG   0x04
#define TEA_INTFLAG_FRRFLAG  0x02
#define TEA_INTFLAG_BLFLAG   0x01

//1R 0W INT MASK
#define TEA5764_INTMASK_DAVMSK   0x80
#define TEA5764_INTMASK_LSYMSK   0x20
#define TEA5764_INTMASK_IFMSK    0x10
#define TEA5764_INTMASK_LEVMSK   0x08
#define TEA5764_INTMASK_PDMSK    0x04
#define TEA5764_INTMASK_FRMSK    0x02
#define TEA5764_INTMASK_BLMSK    0x01

//2R 1W FRQSETMSB
#define TEA5764_FRQSETM_SUD      0x80
#define TEA5764_FRQSETM_SM       0x40
#define TEA5764_FRQSETM_FR_H     0x3F

//3R 2W FRQSETLSB
#define TEA5764_FRQSETL_FR_L     0xFF

//4R 3W INT MASK
#define TEA5764_TNCTRL1_PUPD     0xC0
#define TEA5764_TNCTRL1_BLIM     0x20
#define TEA5764_TNCTRL1_SWPM     0x10
#define TEA5764_TNCTRL1_IFCTC    0x08
#define TEA5764_TNCTRL1_AFM      0x04
#define TEA5764_TNCTRL1_SMUTE    0x02
#define TEA5764_TNCTRL1_SNC      0x01

//5R 4W INT MASK
#define TEA5764_TNCTRL2_MU       0x80
#define TEA5764_TNCTRL2_SS       0x60
#define TEA5764_TNCTRL2_HLSI     0x10
#define TEA5764_TNCTRL2_MST      0x08
#define TEA5764_TNCTRL2_SWP      0x04
#define TEA5764_TNCTRL2_DTC      0x02
#define TEA5764_TNCTRL2_AHLSI    0x01

#define TEA5764_TNCTRL2_SS_ADC3  0x00
#define TEA5764_TNCTRL2_SS_ADC5  0x20
#define TEA5764_TNCTRL2_SS_ADC7  0x40
#define TEA5764_TNCTRL2_SS_ADC10 0x60

//20R 7W RDS CTRL1
#define TEA5764_RDSCTRL_NWSY     0x80
#define TEA5764_RDSCTRL_SYM_NO   0x60
#define TEA5764_RDSCTRL_RBDS     0x10
#define TEA5764_RDSCTRL_DAC      0xC0

#define TEA5764_RDSCTRL_SYM_2BIT 0x20
#define TEA5764_RDSCTRL_SYM_5BIT 0x40

#define TEA5764_RDSCTRL_DAC_DAVA 0x00
#define TEA5764_RDSCTRL_DAC_DAVB 0x40
#define TEA5764_RDSCTRL_DAC_DAVC 0x80
#define TEA5764_RDSCTRL_DAC_NC   0xC0


//21R 8W RDS CTRL1
//TEST
#define TEA5764_TESTBIT_INTCTL   0x01


#endif	/* TEA5764HN_H */
