/*
 * linux/drivers/video/sonynavu_pxafb.h
 *
 *  Copyright (C) 2005 Sony. t-sakai@me.sony.co.jp
 *
 *
 * Based on
 * linux/drivers/video/pxafb.h
 *    -- Intel PXA250/210 LCD Controller Frame Buffer Device
 *
 */

/*
 *	BASEFRAMEΥԥեޥåȤLM_PF_A1RGB16ˤ롣
 *	ΥޥʤLM_PF_RGB8ˤʤ롣
 */
//#define BASEFRAME_A1RGB16

//Use module parameters
#define CONFIG_FB_PXA_PARAMETERS

//SRAMVRAMݤ뤫ɤ
//#define USE_SRAM
//CaptureInterfaceȤ
//#define USE_CAPTURE
////
#define VIDEO_XRES						320
#define VIDEO_YRES						240

//Base layer Map
#ifdef BASEFRAME_A1RGB16
#define LCD_BASE_BPP					16
#else
#define LCD_BASE_BPP					8
#endif

#define LCD_BASE_MAX_XRES				768	// ѥ󤵤祵
#define LCD_BASE_MAX_YRES				512
#define LCD_BASE_MIN_XRES				480	// ѥ󤵤祵
#define LCD_BASE_MIN_YRES				272

//Overlay1 AFW
#define LCD_OVERLAY1_BPP				16
#define LCD_OVERLAY1_MAX_XRES			480
#define LCD_OVERLAY1_MAX_YRES			272

//Overlay2 Linux
#define LCD_OVERLAY2_BPP				16

//Cursor
#define LCD_CURSOR_BPP					2
#define LCD_CURSOR_XRES					32
#define LCD_CURSOR_YRES					32
//
#define LCD_BPP		LCD_OVERLAY2_BPP

/****For QVGA panel****/
#define QVGA_LCD_XRES					320
#define QVGA_LCD_YRES					240

/****For Wide-QVGA panel****/
#define WQVGA_LCD_XRES					480
#define WQVGA_LCD_YRES					272


//Memory Map
/*
 *	0x000000000x0003FBFF	Overlay2ΥХåե
 *							261120 = 480x272x2byte(16bit顼)
 *	0x0003FC000x0003FFFF	Overlay2Υѥå
 *							1024 = 256(ѥå)x4byte(32bit顼)
 *	0x000400000x000403FF	Overlay1(UI)Υѥå
 *							1024 = 256(ѥå)x4byte(32bit顼)
 *	0x000404000x0007FFFF	Overlay1(UI)ΥХåե(ɽ)
 *							261120 = 480x272x2byte(16bit顼)
 *	0x000800000x000BFBFF	Overlay1(UI)ΥХåե(΢)
 *							261120 = 480x272x2byte(16bit顼)
 *	0x000BFC000x000BFFFF	CursorΥѥå
 *							1024 = 256(ѥå)x4byte(32bit顼)
 *	0x000C00000x000C03FF	CursorΥХåե
 *							1024 = 32x32x0.25(2bit顼)x4(ѥ)
 *	[8bitǥå顼]
 *
 *	0x000C04000x000C07FF	BaseFrame(Map)Υѥå
 *							1024 = 256(ѥå)x4byte(32bit顼)
 *	0x000C08000x001207FF	BaseFrame(Map)ΥХåե(ɽ)
 *							393216(0x60000) = 768x512x1byte(8bitǥå顼)
 *	0x001208000x001807FF	BaseFrame(Map)ΥХåե(΢)
 *							393216(0x60000) = 768x512x1byte(8bitǥå顼)
 *	0x001808000x00180BFF	ǥѥå
 *							1024?
 *	0x00180C000x0018FFFF	ޤ
 *	0x00190000			Video(0x001B5800ޤ)
 *							153600(0x25800) = 320*240 + 320*240/2 + 320*240/2
 *
 *	[16bit顼]
 *
 *	0x000C04000x000C07FF	BaseFrame(Map)Υѥå
 *							1024 = 256(ѥå)x4byte(32bit顼)
 *	0x000C08000x001807FF	BaseFrame(Map)ΥХåե(ɽ)
 *							72642C(0xC0000) = 768x512x2byte(16bit顼)
 *	0x001808000x002407FF	BaseFrame(Map)ΥХåե(΢)
 *							72642C(0xC0000) = 768x512x2byte(16bit顼)
 *	0x002408000x00240BFF	ǥѥå
 *							1024?
 *	0x00240C000x0024FFFF	ޤ
 *	0x00250000			Video(0x001B5800ޤ)
 *							153600(0x25800) = 320*240 + 320*240/2 + 320*240/2
 */

#ifdef USE_CAPTURE
#ifdef BASEFRAME_A1RGB16
#define VRAMSIZE	(2*1024*1024-0x6000)+0xC0000	// 2859008(0x002BA000)
#else
#define VRAMSIZE	(2*1024*1024-0x6000)			// 2072576(0x001FA000)
#endif
#else
#ifdef BASEFRAME_A1RGB16
#define VRAMSIZE	((1024+768)*1024)+0xC0000		// 2621440(0x00280000)
#else
#define VRAMSIZE	((1024+768)*1024)				// 1835008(0x001C0000)
#endif
#endif

#define OFFSET_CURSOR_PAL	(0x000BFC00)				// Cursor
#define OFFSET_CURSOR_0		(OFFSET_CURSOR_PAL + 1024)	// Cursor
#define OFFSET_CURSOR_1		(OFFSET_CURSOR_0 + 256)		// Cursor
#define OFFSET_CURSOR_2		(OFFSET_CURSOR_1 + 256)		// Cursor
#define OFFSET_CURSOR_3		(OFFSET_CURSOR_2 + 256)		// Cursor

#define OFFSET_BASELAYER	(0x000C0400)				// Map
#define OFFSET_BASELAYER_0	(OFFSET_BASELAYER+1024)		// Map
#define OFFSET_BASELAYER_1	(OFFSET_BASELAYER_0 + (LCD_BASE_MAX_XRES * LCD_BASE_MAX_YRES * LCD_BASE_BPP / 8))	// Map
#ifdef BASEFRAME_A1RGB16
#define OFFSET_BASELAYER_PALWORK		(0x00240800)	// Map
#else
#define OFFSET_BASELAYER_PALWORK		(0x00180800)	// Map
#endif

#define OFFSET_OVERLAY1		(0x00040000)				// UI
#define OFFSET_OVERLAY1_0	(OFFSET_OVERLAY1 + 1024)	// UI
#define OFFSET_OVERLAY1_1	(OFFSET_OVERLAY1_0 + (LCD_OVERLAY1_MAX_XRES * LCD_OVERLAY1_MAX_YRES * LCD_OVERLAY1_BPP /8))	// UI

#define OFFSET_OVERLAY2		(0x0003FC00)				// Linux
#define OFFSET_OVERLAY2_0	(0x00000000)

#ifdef BASEFRAME_A1RGB16
#define OFFSET_VIDEO		(0x00250000)				// Video
#else
#define OFFSET_VIDEO		(0x00190000)				// Video
#endif


//DMA Descriptor
#define DMA_DESC_OFFSET_FRAME2_FB0	(0)			// Overlay2 Хåե16(0x10)
#define DMA_DESC_OFFSET_FRAME2_PAL	(0x10)		// Overlay2 ѥåȡ16(0x10)
#define DMA_DESC_OFFSET_CURSOR_FB0	(0x20)		// Cursor Хåե16(0x10)
#define DMA_DESC_OFFSET_CURSOR_PAL	(0x30)		// Cursor ѥåȡ16(0x10)
#define DMA_DESC_OFFSET_FRAME1_PAL	(0x40)		// Overlay1(UI)Υѥåȡ16(0x10)
#define DMA_DESC_OFFSET_FRAME1_FB0	(0x50)		// Overlay1(UI)Υ饤ʬ4352(0x1100)=16*272
#define DMA_DESC_OFFSET_FRAME0_PAL	(0x1150)	// BaseFrame(Map)Υѥå16(0x10)
#define DMA_DESC_OFFSET_FRAME0_FB0	(0x1160)	// BaseFrame(MAP)Υ饤ʬ4352(0x1100)=16*272
#define DMA_DESC_OFFSET_VIDEO_Y		(0x2260)	// VIDEO(Y) 
#define DMA_DESC_OFFSET_VIDEO_B		(0x2270)	// VIDEO(B)
#define DMA_DESC_OFFSET_VIDEO_R		(0x2280)	// VIDEO(R) 

//LCD Panel dependent parameter
#define LCD_HORIZONTAL_SYNC_PULSE_WIDTH	1
#define LCD_VERTICAL_SYNC_PULSE_WIDTH	1
#define LCD_BEGIN_OF_LINE_WAIT_COUNT	3
#define LCD_BEGIN_FRAME_WAIT_COUNT		0
#define LCD_END_OF_LINE_WAIT_COUNT		3
#define LCD_END_OF_FRAME_WAIT_COUNT		0
#define LCD_SYNC						(FB_SYNC_HOR_HIGH_ACT | FB_SYNC_VERT_HIGH_ACT)

//----------------------------------------------------------------
// LCD Controller Control Register 0(LCCR0)
//----------------------------------------------------------------

#ifdef BASEFRAME_A1RGB16
	// LDDALT=0 OUC=1 PAS=1
	// #define LCD_LCCR0					(0x02000080 | LCCR0_LDM | LCCR0_OUM | LCCR0_IUM |  LCCR0_CMDIM | LCCR0_RDSTM | LCCR0_QDM | LCCR0_BM )
	// LDDALT=1 OUC=1 PAS=1
	#define LCD_LCCR0						(0x06000080 | LCCR0_LDM | LCCR0_OUM | LCCR0_IUM |  LCCR0_CMDIM | LCCR0_RDSTM | LCCR0_QDM | LCCR0_BM )
#else
	// LDDALT=1 OUC=1 PAS=1
	#define LCD_LCCR0						(0x06000080 | LCCR0_LDM | LCCR0_OUM | LCCR0_IUM |  LCCR0_CMDIM | LCCR0_RDSTM | LCCR0_QDM | LCCR0_BM )
#endif

//----------------------------------------------------------------
// LCD Controller Control Register 1 (LCCR1)
//----------------------------------------------------------------

/****For QVGA panel****/
// LCCR1:BLW=10 ELW=116 HSW=63 PPL=319
#define QVGA_LCD_LCCR1			((10<<24) | (116<<16) | (63<<10) | (320-1))

/****For Wide-QVGA panel****/
// LCCR1:BLW=2 ELW=2 HSW=38 PPL=479
#define WQVGA_LCD_LCCR1			((2<<24) | (2<<16) | (38<<10) | (480-1)) 

//----------------------------------------------------------------
// LCD Controller Control Register 2 (LCCR2)
//----------------------------------------------------------------

/****For QVGA panel****/
// LCCR2:BFW=1 EFW=0 VSW=0  LPP=239
#define QVGA_LCD_LCCR2			((1<<24) | (0<<16) | (0<<10) | (240-1)) 

/****For Wide-QVGA panel****/
// LCCR2:BFW=3 EFW=3 VSW=7  LPP=271
#define WQVGA_LCD_LCCR2			((3<<24) | (2<<16) | (7<<10) | (272-1))


//----------------------------------------------------------------
// LCD Controller Control Register 3 (LCCR3)
//----------------------------------------------------------------

#ifdef BASEFRAME_A1RGB16
/****For QVGA panel****/
//LCCR3: PDFOR=3 BPP=4 PCP=1 HSP=1 VSP=0 API=0 ACB=0 PCD=14
#define QVGA_LCD_LCCR3			((3<<30) | (4<<24) | (1<<22) | (1<<21) | (0<<20) | (0<<8) | ( 14))
/****For Wide-QVGA panel****/
//LCCR3: PDFOR=3 BPP=4 PCP=1 HSP=1 VSP=1 API=0 ACB=0 PCD=11
#define WQVGA_LCD_LCCR3			((3<<30) | (4<<24) | (1<<22) | (1<<21) | (1<<20) | (0<<8) | ( 11))
#else
/****For QVGA panel****/
//LCCR3: PDFOR=3 BPP=3 PCP=1 HSP=1 VSP=0 API=0 ACB=0 PCD=14
#define QVGA_LCD_LCCR3			((3<<30) | (3<<24) | (1<<22) | (1<<21) | (0<<20) | (0<<8) | ( 14))
/****For Wide-QVGA panel****/
//LCCR3: PDFOR=3 BPP=3 PCP=1 HSP=1 VSP=1 API=0 ACB=0 PCD=11
#define WQVGA_LCD_LCCR3			((3<<30) | (3<<24) | (1<<22) | (1<<21) | (1<<20) | (0<<8) | ( 11))
#endif

//----------------------------------------------------------------
// LCD Controller Control Register 4 (LCCR4)
//----------------------------------------------------------------

#ifdef BASEFRAME_A1RGB16
//PCDDIV=1 PAL_FOR=0 Transparent=6
#define QVGA_LCD_LCCR4			(0x80000000 | (6<<6) | (6<<3) | (6))
//PCDDIV=1 PAL_FOR=0 Transparent=6
#define WQVGA_LCD_LCCR4			(0x80000000 | (6<<6) | (6<<3) | (6))
#else
//PCDDIV=1 PAL_FOR=1 Transparent=6
#define QVGA_LCD_LCCR4			(0x80008000 | (6<<6) | (6<<3) | (6))
//PCDDIV=1 PAL_FOR=1 Transparent=6
#define WQVGA_LCD_LCCR4			(0x80008000 | (6<<6) | (6<<3) | (6))
#endif

//----------------------------------------------------------------
// LCD Controller Control Register 5 (LCCR5)
//----------------------------------------------------------------

#define LCD_LCCR5			0xFFFFFFFF

#ifndef CONFIG_FB_PXA_PARAMETERS
#define LCD_LCCR1  WQVGA_LCD_LCCR1
#define LCD_LCCR2  WQVGA_LCD_LCCR2
#define LCD_LCCR3  WQVGA_LCD_LCCR3
#define LCD_LCCR4  WQVGA_LCD_LCCR4
#endif

//----------------------------------------------------------------
// Overlay 1 Control Register 1/2 (OVL1C1/OVL1C2)
//----------------------------------------------------------------

// Disable 16bit H W AFW 
#define LCD_OVL1C1(xres,yres)	((0x00400000) | (((yres)-1)<<10) | (((xres)-1)))
#define LCD_OVL1C2(xpos,ypos)	(((ypos)<<10) | (xpos))	// Y X
// Enable 16bit H W Linux
#define LCD_OVL2C1(xres,yres)	((0x00400000) | (((yres)-1)<<10) | (((xres)-1)))
#define LCD_OVL2C2(xpos,ypos)	(((ypos)<<10) | (xpos))	// Y X

//----------------------------------------------------------------
// Cursor Control Register (CCR)
//----------------------------------------------------------------

//Disable Y X 32x32x2bpp 3-color and transparency mode
#define LCD_CURSOR     ((0x00000000) | (100<<15) | ( 150 << 5 ) | 0x1) // Y X



//Add SAKAI 050905
#define INTERNAL_SRAM_PHYS_ADDR (0x5c000000)
#define INTERNAL_SRAM_SIZE (256*1024)

/******* Registers *********/
/* Overlay1 & Overlay2 & Hardware Cursor */
#define LCSR1_SOF1	(1 << 0)
#define LCSR1_SOF2	(1 << 1)
#define LCSR1_SOF3	(1 << 2)
#define LCSR1_SOF4	(1 << 3)
#define LCSR1_SOF5	(1 << 4)
#define LCSR1_SOF6	(1 << 5)

#define LCSR1_EOF1	(1 << 8)
#define LCSR1_EOF2	(1 << 9)
#define LCSR1_EOF3	(1 << 10)
#define LCSR1_EOF4	(1 << 11)
#define LCSR1_EOF5	(1 << 12)
#define LCSR1_EOF6	(1 << 13)

#define LCSR1_BS1	(1 << 16)
#define LCSR1_BS2	(1 << 17)
#define LCSR1_BS3	(1 << 18)
#define LCSR1_BS4	(1 << 19)
#define LCSR1_BS5	(1 << 20)
#define LCSR1_BS6	(1 << 21)

#define LCSR1_IU2	(1 << 25)
#define LCSR1_IU3	(1 << 26)
#define LCSR1_IU4	(1 << 27)
#define LCSR1_IU5	(1 << 28)
#define LCSR1_IU6	(1 << 29)

#define LDCMD_SOFINT	(1 << 22)
#define LDCMD_EOFINT	(1 << 21)

#define LCCR5_SOFM1	(1<<0)		/* Start Of Frame Mask for Overlay 1 (channel 1) */
#define LCCR5_SOFM2	(1<<1)		/* Start Of Frame Mask for Overlay 2 (channel 2) */
#define LCCR5_SOFM3	(1<<2)		/* Start Of Frame Mask for Overlay 2 (channel 3) */
#define LCCR5_SOFM4	(1<<3)		/* Start Of Frame Mask for Overlay 2 (channel 4) */
#define LCCR5_SOFM5	(1<<4)		/* Start Of Frame Mask for cursor (channel 5) */
#define LCCR5_SOFM6	(1<<5)		/* Start Of Frame Mask for command data (channel 6) */

#define LCCR5_EOFM1	(1<<8)		/* End Of Frame Mask for Overlay 1 (channel 1) */
#define LCCR5_EOFM2	(1<<9)		/* End Of Frame Mask for Overlay 2 (channel 2) */
#define LCCR5_EOFM3	(1<<10)		/* End Of Frame Mask for Overlay 2 (channel 3) */
#define LCCR5_EOFM4	(1<<11)		/* End Of Frame Mask for Overlay 2 (channel 4) */
#define LCCR5_EOFM5	(1<<12)		/* End Of Frame Mask for cursor (channel 5) */
#define LCCR5_EOFM6	(1<<13)		/* End Of Frame Mask for command data (channel 6) */

#define LCCR5_BSM1	(1<<16)		/* Branch mask for Overlay 1 (channel 1) */
#define LCCR5_BSM2	(1<<17)		/* Branch mask for Overlay 2 (channel 2) */
#define LCCR5_BSM3	(1<<18)		/* Branch mask for Overlay 2 (channel 3) */
#define LCCR5_BSM4	(1<<19)		/* Branch mask for Overlay 2 (channel 4) */
#define LCCR5_BSM5	(1<<20)		/* Branch mask for cursor (channel 5) */
#define LCCR5_BSM6	(1<<21)		/* Branch mask for data command  (channel 6) */

#define LCCR5_IUM1	(1<<24)		/* Input FIFO Underrun Mask for Overlay 1  */
#define LCCR5_IUM2	(1<<25)		/* Input FIFO Underrun Mask for Overlay 2  */
#define LCCR5_IUM3	(1<<26)		/* Input FIFO Underrun Mask for Overlay 2  */
#define LCCR5_IUM4	(1<<27)		/* Input FIFO Underrun Mask for Overlay 2  */
#define LCCR5_IUM5	(1<<28)		/* Input FIFO Underrun Mask for cursor */
#define LCCR5_IUM6	(1<<29)		/* Input FIFO Underrun Mask for data command */

#define OVL1C1_O1EN	(1<<31)		/* Enable bit for Overlay 1 */
#define OVL2C1_O2EN	(1<<31)		/* Enable bit for Overlay 2 */
#define CCR_CEN		(1<<31)		/* Enable bit for Cursor */

//Add SAKAI 050829
#define LCCR4		__REG(0x44000010)  /* LCD Controller Control Register 4 */
#define LCCR5		__REG(0x44000014)  /* LCD Controller Control Register 5 */

#define LCSR1		__REG(0x44000034)  /* LCD Controller Status Register 1*/
#define LCSR0		__REG(0x44000038)  /* LCD Controller Status Register 0*/


#define LDCMD_EOFINT	(1 << 21)	/* instructs End of Frame */
#define LDCMD_SOFINT	(1 << 22)	/* instructs End of Frame */

#define OVL1C1      __REG(0x44000050)  /*Overlay 1 Control Register 1*/
#define OVL1C2      __REG(0x44000060)  /*Overlay 1 Control Register 2*/
#define OVL2C1      __REG(0x44000070)  /*Overlay 2 Control Register 1*/
#define OVL2C2      __REG(0x44000080)  /*Overlay 2 Control Register 2*/
#define CURSOR		__REG(0x44000090)  /*Cursor Control register*/

#define FDADR2		__REG(0x44000220)  /* DMA Channel 2 Frame Descriptor Address Register */
#define FSADR2		__REG(0x44000224)  /* DMA Channel 2 Frame Source Address Register */
#define FIDR2		__REG(0x44000228)  /* DMA Channel 2 Frame ID Register */
#define LDCMD2		__REG(0x4400022C)  /* DMA Channel 2 Command Register */
#define DFBR2		__REG(0x44000028)  /* DMA Channel 2 Frame Branch Register */

#define FDADR3		__REG(0x44000230)  /* DMA Channel 3 Frame Descriptor Address Register */
#define FSADR3		__REG(0x44000234)  /* DMA Channel 3 Frame Source Address Register */
#define FIDR3		__REG(0x44000238)  /* DMA Channel 3 Frame ID Register */
#define LDCMD3		__REG(0x4400023C)  /* DMA Channel 3 Command Register */
#define DFBR3		__REG(0x4400002C)  /* DMA Channel 3 Frame Branch Register */

#define FDADR4		__REG(0x44000240)  /* DMA Channel 4 Frame Descriptor Address Register */
#define FSADR4		__REG(0x44000244)  /* DMA Channel 4 Frame Source Address Register */
#define FIDR4		__REG(0x44000248)  /* DMA Channel 4 Frame ID Register */
#define LDCMD4		__REG(0x4400024C)  /* DMA Channel 4 Command Register */
#define DFBR4		__REG(0x44000030)  /* DMA Channel 4 Frame Branch Register */

#define FDADR5		__REG(0x44000250)  /* DMA Channel 5 Frame Descriptor Address Register */
#define FSADR5		__REG(0x44000254)  /* DMA Channel 5 Frame Source Address Register */
#define FIDR5		__REG(0x44000258)  /* DMA Channel 5 Frame ID Register */
#define LDCMD5		__REG(0x4400025C)  /* DMA Channel 5 Command Register */
#define DFBR5		__REG(0x44000110)  /* DMA Channel 5 Frame Branch Register */

//for BB1 Board Control Register
#define	BCR	0x0a000000
#define	BCR_REG	0x5c03fff0

/*
 * Activities on VSYNC interrupt
 */
typedef struct{
    atomic_t			waitcnt;
    wait_queue_head_t		waitq;
} sonynavu_pxafb_vsyncinfo_t;

/*
 * These are the bitfields for each
 * display depth that we support.
 */
struct sonynavu_pxafb_rgb {
	struct fb_bitfield	red;
	struct fb_bitfield	green;
	struct fb_bitfield	blue;
	struct fb_bitfield	transp;
};

/*
 * This structure describes the machine which we are running on.
 */
struct sonynavu_pxafb_mach_info {
	u_long		pixclock;

	u_short		xres;
	u_short		yres;

	u_char		bpp;
	u_char		hsync_len;
	u_char		left_margin;
	u_char		right_margin;

	u_char		vsync_len;
	u_char		upper_margin;
	u_char		lower_margin;
	u_char		sync;

	u_int		cmap_greyscale:1,
			cmap_inverse:1,
			cmap_static:1,
			unused:29;

	u_int		lccr0;
	u_int		lccr1; //Add PXA270 SAKAI 050829
	u_int		lccr2; //Add PXA270 SAKAI 050829
	u_int		lccr3;
	u_int		lccr4; //Add PXA270 SAKAI 050829
	u_int		lccr5; //Add PXA270 SAKAI 050829
	u_int			ovl1c1; //Overlay1
	u_int			ovl1c2; //Overlay1
	u_int			ovl2c1; //Overlay2
	u_int			ovl2c2; //Overlay2
	u_int		cursor; //Cursor

};

/* Shadows for LCD controller registers */
struct sonynavu_pxafb_lcd_reg {
	unsigned int lccr0;
	unsigned int lccr1;
	unsigned int lccr2;
	unsigned int lccr3;
	unsigned int lccr4;  //Add PXA270 SAKAI 050829 
	unsigned int lccr5;  //Add PXA270 SAKAI 050829 

};

/* PXA LCD DMA descriptor */
struct sonynavu_pxafb_dma_descriptor {
	unsigned int fdadr; //Υޥ
	unsigned int fsadr; //žɥ쥹
	unsigned int fidr;   // 0Ǥ褤
	unsigned int ldcmd; //ž
};

#define RGB_8	(0)
#define RGB_16	(1)
#define NR_RGB	2

struct sonynavu_capture_info {
	int dma_ch[3];
	wait_queue_head_t	ctrlr_wait;
};

struct FrameSetting  {
		unsigned int   Status;
		unsigned int   Flip;
		 int	DispX;
		 int	DispY;
		unsigned int	DispWidth;
		unsigned int	DispHeight;
		unsigned int	FrameX;
		unsigned int	FrameY;
		unsigned int	FrameWidth;
		unsigned int	FrameHeight;
	};

struct sonynavu_pxafb_info {
	struct fb_info		fb;
	struct device		*dev;
//	signed int		currcon;

//	struct sonynavu_pxafb_rgb	*rgb[NR_RGB];

	u_int			max_bpp;
	u_int			max_xres;
	u_int			max_yres;

	/*
	 * These are the addresses we mapped
	 * the framebuffer memory region to.
	 */

	/* raw memory addresses */
	dma_addr_t		map_dma;	/* physical */
	u_char *		map_cpu;	/* virtual */
	u_int			map_size;

	dma_addr_t		map_dma2;	/* physical */
	u_char *		map_cpu2;	/* virtual */
	u_int			map_size2;
	/* addresses of pieces placed in raw buffer */
	//Overlay2 Video
	u_char *		screenvideo_y_cpu;	/* virtual address of frame buffer */
	dma_addr_t		screenvideo_y_dma;	/* physical address of frame buffer */
	u_char *		screenvideo_b_cpu;	/* virtual address of frame buffer */
	dma_addr_t		screenvideo_b_dma;	/* physical address of frame buffer */
	u_char *		screenvideo_r_cpu;	/* virtual address of frame buffer */
	dma_addr_t		screenvideo_r_dma;	/* physical address of frame buffer */
	//Overlay2 Linux
	u_char *		screen2_cpu;	/* virtual address of frame buffer */
	dma_addr_t		screen2_dma;	/* physical address of frame buffer */
	u32 *			palette2_cpu;	/* virtual address of palette memory */
	dma_addr_t		palette2_dma;	/* physical address of palette memory */
	u_int			palette2_size;
	//Cursor
	u32 *			palette3_cpu;	/* virtual address of palette memory */
	dma_addr_t		palette3_dma;	/* physical address of palette memory */
	u_char *		screen3_cpu0;	/* virtual address of frame buffer */
	dma_addr_t		screen3_dma0;	/* physical address of frame buffer */
	u_char *		screen3_cpu1;	/* virtual address of frame buffer */
	dma_addr_t		screen3_dma1;	/* physical address of frame buffer */
	u_char *		screen3_cpu2;	/* virtual address of frame buffer */
	dma_addr_t		screen3_dma2;	/* physical address of frame buffer */
	u_char *		screen3_cpu3;	/* virtual address of frame buffer */
	dma_addr_t		screen3_dma3;	/* physical address of frame buffer */

	u_int			palette3_size;
	//Overlay1 AFW
	u_char *		screen1_cpu0;	/* virtual address of frame buffer */
	dma_addr_t		screen1_dma0;	/* physical address of frame buffer */
	u32 *			palette1_cpu;	/* virtual address of palette memory */
	dma_addr_t		palette1_dma;	/* physical address of palette memory */
	u_char *		screen1_cpu1;	/* virtual address of frame buffer */
	dma_addr_t		screen1_dma1;	/* physical address of frame buffer */
	u_int			palette1_size;
	//Base layer Map
	u_char *		screen0_cpu0;	/* virtual address of frame buffer */
	dma_addr_t		screen0_dma0;	/* physical address of frame buffer */
	u32 *			palette0_cpu;	/* virtual address of palette memory */
	dma_addr_t		palette0_dma;	/* physical address of palette memory */
	u32 *			palette0_work;	/* virtual address of palette work memory */

	u_char *		screen0_cpu1;	/* virtual address of frame buffer */
	dma_addr_t		screen0_dma1;	/* physical address of frame buffer */
	u_int			palette0_size;

	/* DMA descriptors */
	//Overlay2 Video
	struct sonynavu_pxafb_dma_descriptor * 	dmadesc_fbvideoY_cpu;
	dma_addr_t				dmadesc_fbvideoY_dma;
	struct sonynavu_pxafb_dma_descriptor * 	dmadesc_fbvideoB_cpu;
	dma_addr_t				dmadesc_fbvideoB_dma;
	struct sonynavu_pxafb_dma_descriptor * 	dmadesc_fbvideoR_cpu;
	dma_addr_t				dmadesc_fbvideoR_dma;
	
	//Overlay2 Linux
	struct sonynavu_pxafb_dma_descriptor * 	dmadesc_fbover2_cpu;
	dma_addr_t				dmadesc_fbover2_dma;
	struct sonynavu_pxafb_dma_descriptor *	dmadesc_palette2_cpu;
	dma_addr_t				dmadesc_palette2_dma;
	//Cursor
	struct sonynavu_pxafb_dma_descriptor * 	dmadesc_fbcursor_cpu;
	dma_addr_t				dmadesc_fbcursor_dma;
	struct sonynavu_pxafb_dma_descriptor *	dmadesc_palette3_cpu;
	dma_addr_t				dmadesc_palette3_dma;
	//Overlay1 AFW Buffer0
	struct sonynavu_pxafb_dma_descriptor * 	dmadesc_fbover1_cpu;
	dma_addr_t				dmadesc_fbover1_dma;
	struct sonynavu_pxafb_dma_descriptor *	dmadesc_palette1_cpu;
	dma_addr_t				dmadesc_palette1_dma;

	//Base layer Map Buffer0
	struct sonynavu_pxafb_dma_descriptor * 	dmadesc_fbover0_cpu;
	dma_addr_t				dmadesc_fbover0_dma;
	struct sonynavu_pxafb_dma_descriptor *	dmadesc_palette0_cpu;
	dma_addr_t				dmadesc_palette0_dma;

	//DMA Descriptor Address
	dma_addr_t		fdadr0; //Map
	dma_addr_t		fdadr1; //GUI
	dma_addr_t		fdadr2; //Linux
	dma_addr_t		fdadr5; //Cursor
	dma_addr_t		fdadrY; //Video Y
	dma_addr_t		fdadrB; //Video B
	dma_addr_t		fdadrR; //Video R
	//Cotrol Register Setting
	u_int			lccr0;
	u_int			lccr1; //Add PXA270 SAKAI 050829 
	u_int			lccr2; //Add PXA270 SAKAI 050829 
	u_int			lccr3;
	u_int			lccr4; //Add PXA270 SAKAI 050829 
	u_int			lccr5; //Add PXA270 SAKAI 050829 
	//Overlay Register
	u_int			ovl1c1; //Overlay1
	u_int			ovl1c2; //Overlay1
	u_int			ovl2c1; //Overlay2
	u_int			ovl2c2; //Overlay2
	u_int			cursor; //Cursor
	//
	u_int			cmap_inverse:1,cmap_static:1,unused:30;

	/*ɽ  ʤɤˤĤƤξ*/
	int    LCDStatus;
	//Baseframe
	struct FrameSetting  Baseframe;
	int ScrollStatus;
	int ScrollFlip;
	int ScrollTargetX;
	int ScrollTargetY;
	int ScrollSpeedX;
	int ScrollSpeedY;
	
	//Overlay1 (GUI)
	struct FrameSetting Overlay1;
	int RequestFlip;

	//Overlay2_Console
	struct FrameSetting Overlay2_Console;

	//Overlay2_Video
	struct FrameSetting Overlay2_Video;
	
	//Cursor
	struct FrameSetting Cursor;
	

	//
	volatile u_char		state;
	volatile u_char		task_state;
	struct semaphore	ctrlr_sem;
	atomic_t			ctrlr_waitcnt;
	wait_queue_head_t	ctrlr_wait;
	struct work_struct	task;

#ifdef CONFIG_PM
	struct pm_dev		*pm;
#endif
#ifdef CONFIG_CPU_FREQ
	struct notifier_block	clockchg;
#endif
	sonynavu_pxafb_vsyncinfo_t	vsyncinfo;
  
	struct sonynavu_capture_info NaviuCaptureInfo;
};

#define __type_entry(ptr,type,member) ((type *)((char *)(ptr)-offsetof(type,member)))

#define TO_INF(ptr,member)	__type_entry(ptr,struct sonynavu_pxafb_info,member)

/*
 * These are the actions for set_ctrlr_state
 */
#define C_DISABLE		(0)
#define C_ENABLE		(1)
#define C_DISABLE_CLKCHANGE	(2)
#define C_ENABLE_CLKCHANGE	(3)
#define C_REENABLE		(4)
#define C_DISABLE_PM		(5)
#define C_ENABLE_PM		(6)
#define C_STARTUP		(7)

#define NAVU_NAME	"NAVU"

/*
 *  Debug macros 
 */
#if DEBUG
#  define DPRINTK(fmt, args...)	printk("%s: " fmt, __FUNCTION__ , ## args)
#else
#  define DPRINTK(fmt, args...)
#endif

/*
 * Minimum X and Y resolutions
 */
#define MIN_XRES	64
#define MIN_YRES	64



#define LCD_PIXCLOCK                    150000

#ifndef __KERNEL__
#include <sys/ioctl.h>
#endif

 /*------------------------------------------------*/
/* PXA270 Frame Buffer Driver IOCTL Definition    */
/*------------------------------------------------*/
/* ioctl */
#define	PXA270FB_IOC_MAGIC		'T'
#define FBIO_PXA270_DISP				_IO(PXA270FB_IOC_MAGIC,   1)

#define FBIO_PXA270_LAYER2				_IO(PXA270FB_IOC_MAGIC,   10)
#define FBIO_PXA270_SETDISP2			_IO(PXA270FB_IOC_MAGIC,   11)
#define FBIO_PXA270_GETDISP2			_IO(PXA270FB_IOC_MAGIC,   12)
#define FBIO_PXA270_GETBASE2			_IO(PXA270FB_IOC_MAGIC,   13)

#define	FBIO_PXA270_LAYER1				_IO(PXA270FB_IOC_MAGIC,   20)
#define	FBIO_PXA270_SETPAL1				_IO(PXA270FB_IOC_MAGIC,   21)
#define	FBIO_PXA270_SELBUF1				_IO(PXA270FB_IOC_MAGIC,   22)
#define FBIO_PXA270_SETTRANS1			_IO(PXA270FB_IOC_MAGIC,   23)
#define FBIO_PXA270_SETDISP1			_IO(PXA270FB_IOC_MAGIC,   24)
#define FBIO_PXA270_GETDISP1			_IO(PXA270FB_IOC_MAGIC,   25)
#define FBIO_PXA270_GETBASE1			_IO(PXA270FB_IOC_MAGIC,   26)

#define FBIO_PXA270_SETPAL0				_IO(PXA270FB_IOC_MAGIC,   30)
#define FBIO_PXA270_GETPAL0				_IO(PXA270FB_IOC_MAGIC,   39)
#define FBIO_PXA270_SETSCROLL0			_IO(PXA270FB_IOC_MAGIC,   31)
#define FBIO_PXA270_GETSCROLL0			_IO(PXA270FB_IOC_MAGIC,   32)
#define FBIO_PXA270_SELBUF0				_IO(PXA270FB_IOC_MAGIC,   37)
#define FBIO_PXA270_SETFRAME0			_IO(PXA270FB_IOC_MAGIC,   34)
#define FBIO_PXA270_GETFRAME0			_IO(PXA270FB_IOC_MAGIC,   35)
#define FBIO_PXA270_GETBASE0			_IO(PXA270FB_IOC_MAGIC,   36)
#define FBIO_PXA270_SETSCROLL_FLIP0			_IO(PXA270FB_IOC_MAGIC,   130)

#define FBIO_PXA270_SETPALCRS			_IO(PXA270FB_IOC_MAGIC,   40)
#define FBIO_PXA270_DISPPOSCRS			_IO(PXA270FB_IOC_MAGIC,   41)
#define FBIO_PXA270_CURSOR				_IO(PXA270FB_IOC_MAGIC,   42)
#define FBIO_PXA270_GETBASECURSOR		_IO(PXA270FB_IOC_MAGIC,   43)
#define FBIO_PXA270_SELCRS   			_IO(PXA270FB_IOC_MAGIC,   44)


#define	FBIO_PXA270_WAITVSYNC			_IO(PXA270FB_IOC_MAGIC,   50)
#define	FBIO_PXA270_WAITSTARTFRAME		_IO(PXA270FB_IOC_MAGIC,   51)

#define FBIO_PXA270_STARTCAPTURE		_IO(PXA270FB_IOC_MAGIC,   60)
#define FBIO_PXA270_STOPCAPTURE			_IO(PXA270FB_IOC_MAGIC,   61)
#define FBIO_PXA270_GETFRAMEVIDEO		_IO(PXA270FB_IOC_MAGIC,   66)
#define FBIO_PXA270_GETDISPVIDEO		_IO(PXA270FB_IOC_MAGIC,   62)
#define FBIO_PXA270_GETBASEVIDEO_Y		_IO(PXA270FB_IOC_MAGIC,   63)
#define FBIO_PXA270_GETBASEVIDEO_B		_IO(PXA270FB_IOC_MAGIC,   64)
#define FBIO_PXA270_GETBASEVIDEO_R		_IO(PXA270FB_IOC_MAGIC,   65)

//for Overlay1 
typedef struct tagDISPSETTING1  {
	unsigned int	DispX;
	unsigned int	DispY;
	unsigned int	DispWidth;
	unsigned int	DispHeight;
	unsigned int	FrameX;
	unsigned int	FrameY;
} PXA270_DISPSETTING1;

//for Overlay2 
typedef struct tagDISPSETTING2  {
	unsigned int	DispX;
	unsigned int	DispY;
	unsigned int	DispWidth;
	unsigned int	DispHeight;
} PXA270_DISPSETTING2;

//for Baseframe
typedef struct tagGETSCROLL0  {
	unsigned int	FrameX;
	unsigned int	FrameY;
	unsigned int	Flag;
} PXA270_GETSCROLL0;

//for Baseframe
typedef struct tagSETSCROLL0  {
	unsigned int	FrameX;
	unsigned int	FrameY;
	int				SpeedFrameX;
	int				SpeedFrameY;
} PXA270_SETSCROLL0;

//for Baseframe
typedef struct tagSETSCROLLFLIP0  {
	unsigned int	FrameX;
	unsigned int	FrameY;
	int				SpeedFrameX;
	int				SpeedFrameY;
	unsigned int	StartX;
	unsigned int	StartY;
	unsigned int	Flip;
} PXA270_SETSCROLL_FLIP0;

typedef struct tagDISPSETTING0  {
	unsigned int	FrameWidth;
	unsigned int	FrameHeight;
} PXA270_DISPSETTING0;

//for Video

typedef struct tagFRAMESETTINGVIDEO  {
	unsigned int	FrameWidth;
	unsigned int	FrameHeight;
} PXA270_FRAMESETTINGVIDEO;

//for Video
typedef struct tagDISPSETTINGVIDEO  {
	unsigned int	DispX;
	unsigned int	DispY;
	unsigned int	DispWidth;
	unsigned int	DispHeight;
} PXA270_DISPSETTINGVIDEO;

