/****************************************************************************
 *
 * Kernel Private Definitions - !!! DON'T USE DIRECTLY from user programs !!!
 *
 *
 ****************************************************************************/
#ifndef NAVU_GPIO_KERNEL_H
#define NAVU_GPIO_KERNEL_H

#ifndef __KERNEL__
#ifndef NAVU_GPIO_KERNEL_H_IS_KERNEL_ONLY
#error  "DO NOT INCLUDE navu-gpio-kernel.h directry from user programs"
#endif/*NAVU_GPIO_KERNEL_H_IS_KERNEL_ONLY*/
#endif/*__KERNEL__*/


/**
 * GPIO manipulation functions - prototype
 *
 *
 */
extern int navuGpioGetLevel(unsigned long port);
extern int navuGpioSetLevel(unsigned long port, int level);
extern int navuGpioIrqWait( navu_irq_ioctl_t *arg );
extern int navuGpioIrqCancel(unsigned long port);


#define NAVU_GP_LOW_WORD    (0x00000000)
#define NAVU_GP_HIGH_WORD   (0x00010000)
#define NAVU_GPxR0          (0x00000000)
#define NAVU_GPxR1          (0x00100000)
#define NAVU_GPxR2          (0x00200000)
#define NAVU_GPxR3          (0x00400000)

#define NAVU_GPREG_MASK     (NAVU_GPxR0 | NAVU_GPxR1 | NAVU_GPxR2 | NAVU_GPxR3 )
#define NAVU_GPIO_MASK      (0x0000FFFF)
#define NAVU_GPNUM_MASK     (0xFF000000)

#define NAVU_GPIO_0    ( NAVU_GPxR0 | NAVU_GP_LOW_WORD  | (1 <<  0) | (  0 << 24) )
#define NAVU_GPIO_1    ( NAVU_GPxR0 | NAVU_GP_LOW_WORD  | (1 <<  1) | (  1 << 24) )
#define NAVU_GPIO_2    ( NAVU_GPxR0 | NAVU_GP_LOW_WORD  | (1 <<  2) | (  2 << 24) )
#define NAVU_GPIO_3    ( NAVU_GPxR0 | NAVU_GP_LOW_WORD  | (1 <<  3) | (  3 << 24) )
#define NAVU_GPIO_4    ( NAVU_GPxR0 | NAVU_GP_LOW_WORD  | (1 <<  4) | (  4 << 24) )
#define NAVU_GPIO_5    ( NAVU_GPxR0 | NAVU_GP_LOW_WORD  | (1 <<  5) | (  5 << 24) )
#define NAVU_GPIO_6    ( NAVU_GPxR0 | NAVU_GP_LOW_WORD  | (1 <<  6) | (  6 << 24) )
#define NAVU_GPIO_7    ( NAVU_GPxR0 | NAVU_GP_LOW_WORD  | (1 <<  7) | (  7 << 24) )
#define NAVU_GPIO_8    ( NAVU_GPxR0 | NAVU_GP_LOW_WORD  | (1 <<  8) | (  8 << 24) )
#define NAVU_GPIO_9    ( NAVU_GPxR0 | NAVU_GP_LOW_WORD  | (1 <<  9) | (  9 << 24) )
#define NAVU_GPIO_10   ( NAVU_GPxR0 | NAVU_GP_LOW_WORD  | (1 << 10) | ( 10 << 24) )
#define NAVU_GPIO_11   ( NAVU_GPxR0 | NAVU_GP_LOW_WORD  | (1 << 11) | ( 11 << 24) )
#define NAVU_GPIO_12   ( NAVU_GPxR0 | NAVU_GP_LOW_WORD  | (1 << 12) | ( 12 << 24) )
#define NAVU_GPIO_13   ( NAVU_GPxR0 | NAVU_GP_LOW_WORD  | (1 << 13) | ( 13 << 24) )
#define NAVU_GPIO_14   ( NAVU_GPxR0 | NAVU_GP_LOW_WORD  | (1 << 14) | ( 14 << 24) )
#define NAVU_GPIO_15   ( NAVU_GPxR0 | NAVU_GP_LOW_WORD  | (1 << 15) | ( 15 << 24) )
#define NAVU_GPIO_16   ( NAVU_GPxR0 | NAVU_GP_HIGH_WORD | (1 <<  0) | ( 16 << 24) )
#define NAVU_GPIO_17   ( NAVU_GPxR0 | NAVU_GP_HIGH_WORD | (1 <<  1) | ( 17 << 24) )
#define NAVU_GPIO_18   ( NAVU_GPxR0 | NAVU_GP_HIGH_WORD | (1 <<  2) | ( 18 << 24) )
#define NAVU_GPIO_19   ( NAVU_GPxR0 | NAVU_GP_HIGH_WORD | (1 <<  3) | ( 19 << 24) )
#define NAVU_GPIO_20   ( NAVU_GPxR0 | NAVU_GP_HIGH_WORD | (1 <<  4) | ( 20 << 24) )
#define NAVU_GPIO_21   ( NAVU_GPxR0 | NAVU_GP_HIGH_WORD | (1 <<  5) | ( 21 << 24) )
#define NAVU_GPIO_22   ( NAVU_GPxR0 | NAVU_GP_HIGH_WORD | (1 <<  6) | ( 22 << 24) )
#define NAVU_GPIO_23   ( NAVU_GPxR0 | NAVU_GP_HIGH_WORD | (1 <<  7) | ( 23 << 24) )
#define NAVU_GPIO_24   ( NAVU_GPxR0 | NAVU_GP_HIGH_WORD | (1 <<  8) | ( 24 << 24) )
#define NAVU_GPIO_25   ( NAVU_GPxR0 | NAVU_GP_HIGH_WORD | (1 <<  9) | ( 25 << 24) )
#define NAVU_GPIO_26   ( NAVU_GPxR0 | NAVU_GP_HIGH_WORD | (1 << 10) | ( 26 << 24) )
#define NAVU_GPIO_27   ( NAVU_GPxR0 | NAVU_GP_HIGH_WORD | (1 << 11) | ( 27 << 24) )
#define NAVU_GPIO_28   ( NAVU_GPxR0 | NAVU_GP_HIGH_WORD | (1 << 12) | ( 28 << 24) )
#define NAVU_GPIO_29   ( NAVU_GPxR0 | NAVU_GP_HIGH_WORD | (1 << 13) | ( 29 << 24) )
#define NAVU_GPIO_30   ( NAVU_GPxR0 | NAVU_GP_HIGH_WORD | (1 << 14) | ( 30 << 24) )
#define NAVU_GPIO_31   ( NAVU_GPxR0 | NAVU_GP_HIGH_WORD | (1 << 15) | ( 31 << 24) )
#define NAVU_GPIO_32   ( NAVU_GPxR1 | NAVU_GP_LOW_WORD  | (1 <<  0) | ( 32 << 24) )
#define NAVU_GPIO_33   ( NAVU_GPxR1 | NAVU_GP_LOW_WORD  | (1 <<  1) | ( 33 << 24) )
#define NAVU_GPIO_34   ( NAVU_GPxR1 | NAVU_GP_LOW_WORD  | (1 <<  2) | ( 34 << 24) )
#define NAVU_GPIO_35   ( NAVU_GPxR1 | NAVU_GP_LOW_WORD  | (1 <<  3) | ( 35 << 24) )
#define NAVU_GPIO_36   ( NAVU_GPxR1 | NAVU_GP_LOW_WORD  | (1 <<  4) | ( 36 << 24) )
#define NAVU_GPIO_37   ( NAVU_GPxR1 | NAVU_GP_LOW_WORD  | (1 <<  5) | ( 37 << 24) )
#define NAVU_GPIO_38   ( NAVU_GPxR1 | NAVU_GP_LOW_WORD  | (1 <<  6) | ( 38 << 24) )
#define NAVU_GPIO_39   ( NAVU_GPxR1 | NAVU_GP_LOW_WORD  | (1 <<  7) | ( 39 << 24) )
#define NAVU_GPIO_40   ( NAVU_GPxR1 | NAVU_GP_LOW_WORD  | (1 <<  8) | ( 40 << 24) )
#define NAVU_GPIO_41   ( NAVU_GPxR1 | NAVU_GP_LOW_WORD  | (1 <<  9) | ( 41 << 24) )
#define NAVU_GPIO_42   ( NAVU_GPxR1 | NAVU_GP_LOW_WORD  | (1 << 10) | ( 42 << 24) )
#define NAVU_GPIO_43   ( NAVU_GPxR1 | NAVU_GP_LOW_WORD  | (1 << 11) | ( 43 << 24) )
#define NAVU_GPIO_44   ( NAVU_GPxR1 | NAVU_GP_LOW_WORD  | (1 << 12) | ( 44 << 24) )
#define NAVU_GPIO_45   ( NAVU_GPxR1 | NAVU_GP_LOW_WORD  | (1 << 13) | ( 45 << 24) )
#define NAVU_GPIO_46   ( NAVU_GPxR1 | NAVU_GP_LOW_WORD  | (1 << 14) | ( 46 << 24) )
#define NAVU_GPIO_47   ( NAVU_GPxR1 | NAVU_GP_LOW_WORD  | (1 << 15) | ( 47 << 24) )
#define NAVU_GPIO_48   ( NAVU_GPxR1 | NAVU_GP_HIGH_WORD | (1 <<  0) | ( 48 << 24) )
#define NAVU_GPIO_49   ( NAVU_GPxR1 | NAVU_GP_HIGH_WORD | (1 <<  1) | ( 49 << 24) )
#define NAVU_GPIO_50   ( NAVU_GPxR1 | NAVU_GP_HIGH_WORD | (1 <<  2) | ( 50 << 24) )
#define NAVU_GPIO_51   ( NAVU_GPxR1 | NAVU_GP_HIGH_WORD | (1 <<  3) | ( 51 << 24) )
#define NAVU_GPIO_52   ( NAVU_GPxR1 | NAVU_GP_HIGH_WORD | (1 <<  4) | ( 52 << 24) )
#define NAVU_GPIO_53   ( NAVU_GPxR1 | NAVU_GP_HIGH_WORD | (1 <<  5) | ( 53 << 24) )
#define NAVU_GPIO_54   ( NAVU_GPxR1 | NAVU_GP_HIGH_WORD | (1 <<  6) | ( 54 << 24) )
#define NAVU_GPIO_55   ( NAVU_GPxR1 | NAVU_GP_HIGH_WORD | (1 <<  7) | ( 55 << 24) )
#define NAVU_GPIO_56   ( NAVU_GPxR1 | NAVU_GP_HIGH_WORD | (1 <<  8) | ( 56 << 24) )
#define NAVU_GPIO_57   ( NAVU_GPxR1 | NAVU_GP_HIGH_WORD | (1 <<  9) | ( 57 << 24) )
#define NAVU_GPIO_58   ( NAVU_GPxR1 | NAVU_GP_HIGH_WORD | (1 << 10) | ( 58 << 24) )
#define NAVU_GPIO_59   ( NAVU_GPxR1 | NAVU_GP_HIGH_WORD | (1 << 11) | ( 59 << 24) )
#define NAVU_GPIO_60   ( NAVU_GPxR1 | NAVU_GP_HIGH_WORD | (1 << 12) | ( 60 << 24) )
#define NAVU_GPIO_61   ( NAVU_GPxR1 | NAVU_GP_HIGH_WORD | (1 << 13) | ( 61 << 24) )
#define NAVU_GPIO_62   ( NAVU_GPxR1 | NAVU_GP_HIGH_WORD | (1 << 14) | ( 62 << 24) )
#define NAVU_GPIO_63   ( NAVU_GPxR1 | NAVU_GP_HIGH_WORD | (1 << 15) | ( 63 << 24) )
#define NAVU_GPIO_64   ( NAVU_GPxR2 | NAVU_GP_LOW_WORD  | (1 <<  0) | ( 64 << 24) )
#define NAVU_GPIO_65   ( NAVU_GPxR2 | NAVU_GP_LOW_WORD  | (1 <<  1) | ( 65 << 24) )
#define NAVU_GPIO_66   ( NAVU_GPxR2 | NAVU_GP_LOW_WORD  | (1 <<  2) | ( 66 << 24) )
#define NAVU_GPIO_67   ( NAVU_GPxR2 | NAVU_GP_LOW_WORD  | (1 <<  3) | ( 67 << 24) )
#define NAVU_GPIO_68   ( NAVU_GPxR2 | NAVU_GP_LOW_WORD  | (1 <<  4) | ( 68 << 24) )
#define NAVU_GPIO_69   ( NAVU_GPxR2 | NAVU_GP_LOW_WORD  | (1 <<  5) | ( 69 << 24) )
#define NAVU_GPIO_70   ( NAVU_GPxR2 | NAVU_GP_LOW_WORD  | (1 <<  6) | ( 70 << 24) )
#define NAVU_GPIO_71   ( NAVU_GPxR2 | NAVU_GP_LOW_WORD  | (1 <<  7) | ( 71 << 24) )
#define NAVU_GPIO_72   ( NAVU_GPxR2 | NAVU_GP_LOW_WORD  | (1 <<  8) | ( 72 << 24) )
#define NAVU_GPIO_73   ( NAVU_GPxR2 | NAVU_GP_LOW_WORD  | (1 <<  9) | ( 73 << 24) )
#define NAVU_GPIO_74   ( NAVU_GPxR2 | NAVU_GP_LOW_WORD  | (1 << 10) | ( 74 << 24) )
#define NAVU_GPIO_75   ( NAVU_GPxR2 | NAVU_GP_LOW_WORD  | (1 << 11) | ( 75 << 24) )
#define NAVU_GPIO_76   ( NAVU_GPxR2 | NAVU_GP_LOW_WORD  | (1 << 12) | ( 76 << 24) )
#define NAVU_GPIO_77   ( NAVU_GPxR2 | NAVU_GP_LOW_WORD  | (1 << 13) | ( 77 << 24) )
#define NAVU_GPIO_78   ( NAVU_GPxR2 | NAVU_GP_LOW_WORD  | (1 << 14) | ( 78 << 24) )
#define NAVU_GPIO_79   ( NAVU_GPxR2 | NAVU_GP_LOW_WORD  | (1 << 15) | ( 79 << 24) )
#define NAVU_GPIO_80   ( NAVU_GPxR2 | NAVU_GP_HIGH_WORD | (1 <<  0) | ( 80 << 24) )
#define NAVU_GPIO_81   ( NAVU_GPxR2 | NAVU_GP_HIGH_WORD | (1 <<  1) | ( 81 << 24) )
#define NAVU_GPIO_82   ( NAVU_GPxR2 | NAVU_GP_HIGH_WORD | (1 <<  2) | ( 82 << 24) )
#define NAVU_GPIO_83   ( NAVU_GPxR2 | NAVU_GP_HIGH_WORD | (1 <<  3) | ( 83 << 24) )
#define NAVU_GPIO_84   ( NAVU_GPxR2 | NAVU_GP_HIGH_WORD | (1 <<  4) | ( 84 << 24) )
#define NAVU_GPIO_85   ( NAVU_GPxR2 | NAVU_GP_HIGH_WORD | (1 <<  5) | ( 85 << 24) )
#define NAVU_GPIO_86   ( NAVU_GPxR2 | NAVU_GP_HIGH_WORD | (1 <<  6) | ( 86 << 24) )
#define NAVU_GPIO_87   ( NAVU_GPxR2 | NAVU_GP_HIGH_WORD | (1 <<  7) | ( 87 << 24) )
#define NAVU_GPIO_88   ( NAVU_GPxR2 | NAVU_GP_HIGH_WORD | (1 <<  8) | ( 88 << 24) )
#define NAVU_GPIO_89   ( NAVU_GPxR2 | NAVU_GP_HIGH_WORD | (1 <<  9) | ( 89 << 24) )
#define NAVU_GPIO_90   ( NAVU_GPxR2 | NAVU_GP_HIGH_WORD | (1 << 10) | ( 90 << 24) )
#define NAVU_GPIO_91   ( NAVU_GPxR2 | NAVU_GP_HIGH_WORD | (1 << 11) | ( 91 << 24) )
#define NAVU_GPIO_92   ( NAVU_GPxR2 | NAVU_GP_HIGH_WORD | (1 << 12) | ( 92 << 24) )
#define NAVU_GPIO_93   ( NAVU_GPxR2 | NAVU_GP_HIGH_WORD | (1 << 13) | ( 93 << 24) )
#define NAVU_GPIO_94   ( NAVU_GPxR2 | NAVU_GP_HIGH_WORD | (1 << 14) | ( 94 << 24) )
#define NAVU_GPIO_95   ( NAVU_GPxR2 | NAVU_GP_HIGH_WORD | (1 << 15) | ( 95 << 24) )
#define NAVU_GPIO_96   ( NAVU_GPxR3 | NAVU_GP_LOW_WORD  | (1 <<  0) | ( 96 << 24) )
#define NAVU_GPIO_97   ( NAVU_GPxR3 | NAVU_GP_LOW_WORD  | (1 <<  1) | ( 97 << 24) )
#define NAVU_GPIO_98   ( NAVU_GPxR3 | NAVU_GP_LOW_WORD  | (1 <<  2) | ( 98 << 24) )
#define NAVU_GPIO_99   ( NAVU_GPxR3 | NAVU_GP_LOW_WORD  | (1 <<  3) | ( 99 << 24) )
#define NAVU_GPIO_100  ( NAVU_GPxR3 | NAVU_GP_LOW_WORD  | (1 <<  4) | (100 << 24) )
#define NAVU_GPIO_101  ( NAVU_GPxR3 | NAVU_GP_LOW_WORD  | (1 <<  5) | (101 << 24) )
#define NAVU_GPIO_102  ( NAVU_GPxR3 | NAVU_GP_LOW_WORD  | (1 <<  6) | (102 << 24) )
#define NAVU_GPIO_103  ( NAVU_GPxR3 | NAVU_GP_LOW_WORD  | (1 <<  7) | (103 << 24) )
#define NAVU_GPIO_104  ( NAVU_GPxR3 | NAVU_GP_LOW_WORD  | (1 <<  8) | (104 << 24) )
#define NAVU_GPIO_105  ( NAVU_GPxR3 | NAVU_GP_LOW_WORD  | (1 <<  9) | (105 << 24) )
#define NAVU_GPIO_106  ( NAVU_GPxR3 | NAVU_GP_LOW_WORD  | (1 << 10) | (106 << 24) )
#define NAVU_GPIO_107  ( NAVU_GPxR3 | NAVU_GP_LOW_WORD  | (1 << 11) | (107 << 24) )
#define NAVU_GPIO_108  ( NAVU_GPxR3 | NAVU_GP_LOW_WORD  | (1 << 12) | (108 << 24) )
#define NAVU_GPIO_109  ( NAVU_GPxR3 | NAVU_GP_LOW_WORD  | (1 << 13) | (109 << 24) )
#define NAVU_GPIO_110  ( NAVU_GPxR3 | NAVU_GP_LOW_WORD  | (1 << 14) | (110 << 24) )
#define NAVU_GPIO_111  ( NAVU_GPxR3 | NAVU_GP_LOW_WORD  | (1 << 15) | (111 << 24) )
#define NAVU_GPIO_112  ( NAVU_GPxR3 | NAVU_GP_HIGH_WORD | (1 <<  0) | (112 << 24) )
#define NAVU_GPIO_113  ( NAVU_GPxR3 | NAVU_GP_HIGH_WORD | (1 <<  1) | (113 << 24) )
#define NAVU_GPIO_114  ( NAVU_GPxR3 | NAVU_GP_HIGH_WORD | (1 <<  2) | (114 << 24) )
#define NAVU_GPIO_115  ( NAVU_GPxR3 | NAVU_GP_HIGH_WORD | (1 <<  3) | (115 << 24) )
#define NAVU_GPIO_116  ( NAVU_GPxR3 | NAVU_GP_HIGH_WORD | (1 <<  4) | (116 << 24) )
#define NAVU_GPIO_117  ( NAVU_GPxR3 | NAVU_GP_HIGH_WORD | (1 <<  5) | (117 << 24) )
#define NAVU_GPIO_118  ( NAVU_GPxR3 | NAVU_GP_HIGH_WORD | (1 <<  6) | (118 << 24) )
#define NAVU_GPIO_119  ( NAVU_GPxR3 | NAVU_GP_HIGH_WORD | (1 <<  7) | (119 << 24) )
#define NAVU_GPIO_120  ( NAVU_GPxR3 | NAVU_GP_HIGH_WORD | (1 <<  8) | (120 << 24) )



/****************************************************************************
 *                        Debug Print Macros
 ****************************************************************************/
#ifdef __KERNEL__
/* #define DEBUG */
#ifdef DEBUG
#define DPRINTK(format,...) \
    printk(KERN_DEBUG "[navu-gpio:%d:%s] " format "\n", __LINE__, __FUNCTION__, ##__VA_ARGS__)
#else
#define DPRINTK(format,...) /*vanish*/
#endif

#define PRINTK(format, ...) \
    printk(KERN_INFO "gpio: " format "\n", ##__VA_ARGS__)

#define PRINTK_ERR(format, ...) \
    printk(KERN_ERR "gpio: " format "\n", ##__VA_ARGS__)

#define PRINTK_WARN(format, ...) \
    printk(KERN_WARNING "gpio: " format "\n", ##__VA_ARGS__)


#define GPIO_BASE_ADDR      0x40E00000
#define GPIO_SIZE           0x200
#define port2irqnum(port)  IRQ_GPIO(((port) & NAVU_GPNUM_MASK) >> 24)
#endif/*__KERNEL__*/

#endif/*NAVU_GPIO_KERNEL_H*/
