/*
 * linux/sound/pxa2xx-wm9705.h
 *     -- AC97 / WM9705 touch panel support for the Intel PXA2xx chip, header.
 *
 * Author:     Hirokazu ABE and Ryoichi KATO
 * Created:    Dec 06, 2005
 * Copyright:  Sony Corp.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef PXA2XX_WM9705_H
#define PXA2XX_WM9705_H

typedef struct {
  unsigned short press;
  unsigned short x;
  unsigned short y;
} TS_DATA;

#define TS_PRESSURE_THRESHOLD 0x800
#define TS_PRESS_MAX 0xFFF
#define TS_X_MAX 0xFFF
#define TS_Y_MAX 0xFFF

/* ioctl */
#define TS_IOC_MAGIC 'f'
#define TS_GET_DATA _IOR(TS_IOC_MAGIC, 1, TS_DATA*)
#define TS_GET_DATA_THROUGH _IOR(TS_IOC_MAGIC, 2, TS_DATA*)
#define TS_CANCEL_BLOCKING _IO(TS_IOC_MAGIC, 3)
#define TS_GET_REG _IOWR(TS_IOC_MAGIC, 100, unsigned short)

#endif /* PXA2XX_WM9705_H */
