/*
 * asm-arm/arch-pxa/xyz3-norheader.h
 *   type of nor flash header for Sony XYZ3, header.
 *
 * Author:     Hirokazu ABE and Ryoichi KATO
 * Created:    Mar 30, 2006
 * Copyright:  Sony Corp.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef XYZ3_NORHEADER_H
#define XYZ3_NORHEADER_H

typedef struct {
    uint32_t id;
    uint32_t start_offset;
    uint32_t length;
    char name[16];
    uint32_t version;
    uint32_t marker_offset;
    uint32_t link;
    uint8_t reserved[24];
} xyz3_norheader;

#define XYZ3_NORHEADER_MAGICNO 0x44414548

typedef struct {
    uint32_t id;
    uint32_t check_sum;
} xyz3_normarker;

#define XYZ3_NORMARKER_MAGICNO 0x544F4F46

#endif /* XYZ3_NORHEADER_H */
