#ifndef __XYZ3_RINGBUF_H
#define __XYZ3_RINGBUF_H

#ifdef __cplusplus
#define _EXTERN_
extern "C" {
#else
#define _EXTERN_	extern
#endif /* __cplusplus */

/*---[ Includes ]-------------------*/
#include <linux/spinlock.h>

/*===[ Define ]===============================================================

    ݡȤ
============================================================================*/

/*--- Private ---*/


/*--- Public ---*/
typedef struct {
	unsigned char	*buf;
	int				bufsize;
	int				elements;
	int				elementSize;
	int				wrPos;		// Next write positin
	int				rdPos;		// Next read position
	spinlock_t		buflock;
} Xyz3RingBuf;

Xyz3RingBuf *xyz3RingBufInit( int elements, int elementSize );
void xyz3RingBufFree( Xyz3RingBuf *ringbuf );
int xyz3RingBufWrite( Xyz3RingBuf *ringbuf, void *data );
int xyz3RingBufRead( Xyz3RingBuf *ringbuf, void *data );


#ifdef __cplusplus
};
#endif /* __cplusplus */
#endif /* __XYZ3_RINGBUF_H */

