/*
 * asm-arm/arch-pxa/xyz4-serial.h
 *     -- Operating System Timers driver on PXA270, header.
 *
 * Author:     Hirokazu ABE and Ryoichi KATO
 * Created:    Feb 16, 2006
 * Copyright:  Sony Corp.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef XYZ4_SERIAL_H
#define XYZ4_SERIAL_H

#include <asm/arch/xyz3-ostimer.h>

/* send mode */
enum {
    SERIAL_MODE_INTERVAL,
    SERIAL_MODE_REALTIME,
};

/* ioctl */
#define SERIAL_IOC_MAGIC 'h'

typedef struct {
    int resolution;
    int count;
} xyz4_serial_interval_setting;

#define SERIAL_SET_INTERVAL _IOW(SERIAL_IOC_MAGIC, 1, xyz4_serial_interval_setting*)
#define SERIAL_SET_MODE_INTERVAL _IO(SERIAL_IOC_MAGIC, 2)
#define SERIAL_SET_MODE_REALTIME _IO(SERIAL_IOC_MAGIC, 3)

typedef struct {
    int baud;
    int parity;
    int hwflow;
} xyz4_serial_port_setting;

enum {
    SERIAL_PARITY_NONE,
    SERIAL_PARITY_EVEN,
    SERIAL_PARITY_ODD,
};

#define SERIAL_INIT _IOW(SERIAL_IOC_MAGIC, 4, xyz4_serial_port_setting*)
#define SERIAL_TERM _IO(SERIAL_IOC_MAGIC, 5)

#endif /* XYZ4_SERIAL_H */
