#ifndef LINUX_SD_CARD_H
#define LINUX_SD_CARD_H

#include <linux/mmc/card.h>

struct sd_scr {
        unsigned char           sda_vsn;
        unsigned char           bus_widths;
#define SD_SCR_BUS_WIDTH_1      (1<<0)
#define SD_SCR_BUS_WIDTH_4      (1<<2)
};

struct sd_card {
	struct list_head	sd_node;	/* node in hosts devices list */
	struct mmc_card		mmc_card;	/* belonging card */
	struct sd_scr		scr;		/* extra SD information */
	u32			raw_scr[2];
}

#define card_list_to_sd(l)	container_of(l,struct sd_card,mmc_card)

#define SD_SEND_RELATIVE_ADDR	3	/* ac			   R6  */ 
  /* Application commands */
#define SD_APP_SET_BUS_WIDTH	6	/* ac   [1:0] bus width    R1  */
#define SD_APP_OP_COND          41	/* bcr  [31:0] OCR         R3  */
#define SD_APP_SEND_SCR         51	/* adtc                    R1  */

#endif      
