#ifndef _TEA5764_H
#define _TEA5764_H

#ifndef __KERNEL__
#include <stdint.h>
#endif

#define FM_I2C_READ			1
#define FM_I2C_WRITE		2

#define RDS_I2C_READ		3
#define RDS_I2C_WRITE		4
#define RDS_CLEAR_BUFFER	5

#define RDS_GET_LEVEL        10
#define RDS_GET_FREQ         11
#define RDS_TUNE             12
#define RDS_GET_ALLREGREAD   13
#define RDS_SEEKFREQENCY     14
#define RDS_READCANCEL       15
#define RDS_READCDATA        16
#define RDS_ALLCANCEL        17
#define RDS_NAVIATT          18
#define RDS_NAVIATT_STS      19
#define RDS_TMC_INIT         20

typedef struct i2c_message {
	uint8_t 	*buf;
	uint16_t	len;
}i2c_message;


/* RDSǡ */
typedef struct {
	uint8_t TmcData[13];
} TMC_RDS_DATA;

/* 쥸 */
typedef struct {
	uint8_t bData[28];
} TMC_RDS_READDATA;

/* Seek׵ */
#define TMC_RDS_SEARCH_UP   0
#define TMC_RDS_SEARCH_DOWN 1

#define TMC_RDS_SEARCH_LEVEL_LIMIT3  0
#define TMC_RDS_SEARCH_LEVEL_LIMIT5  1
#define TMC_RDS_SEARCH_LEVEL_LIMIT7  2
#define TMC_RDS_SEARCH_LEVEL_LIMIT10 3

typedef struct {
	uint8_t bSeekFlag;
	uint8_t bLevelLimit;
	int32_t iResult;
	uint32_t dwBand;
} TMC_RDS_SEEKIN;

/* Seek */
#define TMC_RDS_SEEK_OK      0
#define TMC_RDS_SEEK_LIMIT   1
#define TMC_RDS_SEEK_TIMEOUT 2
#define TMC_RDS_SEEK_NG      3
typedef struct {
	int32_t iResult;
	uint32_t dwBand;
} TMC_RDS_SEEKOUT;


//Navi_Att
#define TMC_RDS_NAVIATT_ON 1
#define TMC_RDS_NAVIATT_OFF 0

#define TMC_RDS_LOG_ON 1
#define TMC_RDS_LOG_OFF 0

//RDS_DATAREAD_THP
#define TMC_THP_TIME_CRITICAL           0
#define TMC_THP_PRIORITY_HIGHEST        1
#define TMC_THP_PRIORITY_ABOVE_NORMAL   2
#define TMC_THP_PRIORITY_NORMAL         3
#define TMC_THP_PRIORITY_BELOW_NORMAL   4
#define TMC_THP_PRIORITY_LOWEST         5
#define TMC_THP_PRIORITY_ABOVE_IDLE     6
#define TMC_THP_PRIORITY_IDLE           7


#endif
